#!/bin/sh


. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh

#check if AVAST enabled before update databases
if [ "x$AVAST_ENABLE" = "xon" ]; then

# create temporary directory 
mkdir -p ${TMPDIR}


touch /tmp/avast.log
TMPAVASTLOG=/tmp/avast1.log


SENDEMAIL_OPTIONS=""
APPEND=""
WEBOUTPUT=""

if [ ! -f /var/ipcop/red/active ] ; then
   echo "no internet connection available, so no updates will be downloaded" |logger -t "antivirus update avast $APPEND"
   exit
fi

if [ "x$1" = "xweboutput" ]; then
  APPEND="<BR>"
fi



if [ -f ${BASEDIR}/etc/smtp_auth_enable ]; then
        SENDEMAIL_OPTIONS="-xu ${SMTP_AUTH_USER} -xp ${SMTP_AUTH_PASS}"
        echo "smtp authentication enabled, using user: ${SMTP_AUTH_USER}"
fi




######################################### SEARCH LAST VERSION ###########################################################

# directory for temporary files
TMPDIR=/tmp/avast-update
# create temporary directory 
mkdir -p ${TMPDIR}

wget -t 3 --no-check-certificate -O /tmp/avast-update/LASTVERSION_AVG http://shelby.eurowireless.de/AVG-mod/LASTVERSION_AVG
		if [ -s /tmp/avast-update/LASTVERSION_AVG ]
		then 
			rm -f "/var/log/copfilter/default/opt/avg/var/log/LASTVERSION_AVG" >/dev/null 2>&1
			cp /tmp/avast-update/LASTVERSION_AVG /var/log/copfilter/default/opt/avg/var/log/LASTVERSION_AVG

		fi


############  UPDATE DATABASE #####################

echo "AVAST updating ..." | logger -t "antivirus update avast"


################### added ###########
echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= AVAST =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=" >> /tmp/avast.log 2>&1
echo $APPEND >> /tmp/avast.log 2>&1
echo $CP_avast_update_mail >> /tmp/avast.log 2>&1
echo $APPEND >> /tmp/avast.log 2>&1
date >> /tmp/avast.log 2>&1
echo "AVAST updating ..." >> /tmp/avast.log 2>&1
/usr/bin/avastvpsupdate.sh >> /tmp/avast.log 2>&1
echo $APPEND >> /tmp/avast.log 2>&1



############### CHECK AVG VERSION ##################################################
. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings

APPEND=""

echo ${APPEND}
echo "" >> /tmp/avast.log 2>&1

lastversion=""
lastversion=$(cat '/var/log/copfilter/default/opt/avg/var/log/LASTVERSION_AVG')

if [ "${LANGUAGE}" = "fr" ]; then 
	echo "La version la plus rcente de l'addon Virus Scanner est: $lastversion "
else
	if [ "${LANGUAGE}" = "de" ]; then
		echo "Neue Version des Virus Scanner mod ist: $lastversion "
	else
		echo "The latest version of Virus Scanner Mod is : $lastversion "
	fi
fi

echo "${APPEND}"

sed 's/\.//g' /var/log/copfilter/default/opt/avg/var/log/LASTVERSION_AVG >>/tmp/LASTVERSION_AVG			
echo "${AVG_MOD}">>/tmp/AVG_MOD1
sed 's/\.//g' /tmp/AVG_MOD1 >/tmp/AVG_MOD
version=$(cat '/tmp/LASTVERSION_AVG')
avgversion=$(cat '/tmp/AVG_MOD')


if [ "$avgversion" -ge "$version" ]; then 
	if [ "${LANGUAGE}" = "fr" ]; then 
		echo "La version installe de l'addon Virus Scanner est: ${AVG_MOD}."
		echo "Votre systme est  jour."
	else
		if [ "${LANGUAGE}" = "de" ]; then
			echo "Die Version ${AVG_MOD} ist installiert. "
			echo "Ihr System ist auf dem neuesten Stand. "
		else
			echo "Version ${AVG_MOD} of Virus Scanner mod is installed "
			echo "Your system is up to date. "

		fi
	fi
else
	if [ "${LANGUAGE}" = "fr" ]; then 

	################## French notification beginning #############################################
		echo "Votre version de l'addon Virus Scanner est : ${AVG_MOD} " >> /tmp/avast.log 2>&1
		echo "Votre version est OBSOLETE!  " >> /tmp/avast.log 2>&1
	################## French notification end #############################################

	else

		if [ "${LANGUAGE}" = "de" ]; then 
		################## German notification beginning #############################################
			echo "Deine Version des Virus Scanner mod ist : ${AVG_MOD} " >> /tmp/avast.log 2>&1
			echo "Deine Version des Virus Scanner mod ist VERALTET ! " >> /tmp/avast.log 2>&1
		################ German notification end #############################################
		else
			################## English notification beginning #############################################
			echo "Your version of Virus Scanner Mod is : ${AVG_MOD} " >> /tmp/avast.log 2>&1
			echo "Your version is Outdated!  " >> /tmp/avast.log 2>&1
			################# English notification end #############################################


		fi
	fi

fi

rm -f /tmp/AVG_MOD
rm -f /tmp/AVG_MOD1
rm -f /tmp/LASTVERSION_AVG
############### END OF CHECK RULES VERSION ##################################################




	########## MODIFY LOG #################################
	cat /tmp/avast.log | sed -e '/^.*s$/d' > $TMPAVASTLOG
	mv -fT $TMPAVASTLOG /tmp/avast.log
	cat /tmp/avast.log | sed \
	's/^\ERROR-0: //g' > $TMPAVASTLOG
	mv -fT $TMPAVASTLOG /tmp/avast.log

	grep "New VPS" /tmp/avast.log >/dev/null 2>&1
	if [ $? = 0 ]; then
		cat /tmp/avast.log >> /var/log/copfilter/default/opt/tools/var/log/avastupd.log 2>&1
	fi




######################## UPDATE CURRENT VERSION FILE ############"
/usr/bin/avastcmd -V >/tmp/CURRENTVERSION_AVAST1 2>&1
sed -n '1p' /tmp/CURRENTVERSION_AVAST1 >/tmp/CURRENTVERSION_AVAST 2>&1
sed 's/avastcmd: avastcmd/AVAST Version/g' /tmp/CURRENTVERSION_AVAST > $BASEDIR/opt/avast/CURRENTVERSION 2>&1

ls -la --time-style=long-iso /var/lib/avast4/ |grep 400.vps | sed 's/  */ /g' | cut -d " " -f 6-7 >/tmp/CURRENTVERSION_AVAST1 2>&1
#ls -la --time-style=long-iso /var/lib/avast4/ |grep 400.vps | sed 's/  */ /g' | cut -d " " -f 6-7 >> $BASEDIR/opt/avast/CURRENTVERSION 2>&1

date_vps=`cat /tmp/CURRENTVERSION_AVAST1`
echo "$date_vps 400.vps" >> $BASEDIR/opt/avast/CURRENTVERSION 2>&1








######################## SEND MAIL ##################
if [ "x$UPDATE_MAIL_NOTIF" = "xoff" -o "x$UPDATE_MAIL_NOTIF" = "xerror" ]; then
	 echo "no email notification will be sent, because this feature is not enabled" 
 elif [ "x$UPDATE_MAIL_NOTIF" = "xon" ]; then
 	echo "email notification will be sent, because this feature is enabled" 

	grep "New VPS" /tmp/avast.log >/dev/null 2>&1

	if [ $? = 0 ]; then
		################## English notification beginning #############################################
		echo "Update was successfully completed "
		cat /tmp/avast.log | ${SENDEMAIL}  ${SENDEMAIL_OPTIONS} -f ${SENDER_ADR} -t ${EMAIL_ADR} -s "${SMTP_HOST}" \
	 	-u "[Copfilter] AntiVirus Update: AVAST " \
		################# English notification end #############################################
	else
		
		echo "You are currently up-to-date "


	
		
	fi
fi

rm -f /tmp/avast.log
rm -f /tmp/avast1.log
rm -r /tmp/avast-update/
rm -f /tmp/CURRENTVERSION_AVAST
rm -f /tmp/CURRENTVERSION_AVAST1

fi

exit


