#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#

# Add entry in menu
# MENUENTRY copfilter 100 "Antivirus" "copfilter antivirus"
#
# Make sure translation exists $Lang::tr{'copfilter antivirus'}


use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/usr/lib/ipcop/general-functions.pl';
require "/usr/lib/ipcop/lang.pl";
require "/usr/lib/ipcop/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $lwdb = '';
my $lwsp = '';
my $lwim ='';
my $output = '';
my $bofatt = '';
my $bofhland = '';
my $bofcrack = '';
my $bofmal = '';
my $bofphish = '';
my $sanesec ='';
my $filetype = '';
my $phish = '';
my $scam = '';
my $jfld = '';
my $scamnailer = '';
my $spam = '';
my $foxgen = '';
my $foxfile = '';
my $foxall = '';
my $spamimg = '';
my $lott = '';
my $spear = '';
my $spearl = '';
my $junk = '';
my $jurlbla = '';
my $jurlbl = '';
my $rogue = '';
my $spamattach = '';
my $oitc='';
my $wmal = '';
my $wext = '';
my $wbad = '';
my $wphsh = '';
my $wpatt = '';
my $wspam = '';
my $wattach = '';
my $blurl = '';
my $sidb = '';
my $sihon = '';
my $sisecinf = '';
my $sibat = '';
my $sidos = '';
my $sielf = '';
my $sihtm = '';
my $simark = '';
my $sioff = '';
my $sipdf = '';
my $sish = '';
my $mbl = '';
my $mbldb = '';
my $main = '';
my $daily = '';
my $version = '';
my $safebrowse = '';
my $bytecode = '';
my $phishtank = '';
my $porcupine = '';
my $porcupdb = '';
my $crdf = '';
my $crdfam = '';
my $style = '';
my $actthrdp = '';
my $sortorder = 2;
my $updatestatus = '';

$copfiltersettings{'ACTION'} = '';
$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("/var/ipcop/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&General::getcgihash(\%copfiltersettings);


# Setting 3rd Sigs default settings if they miss!
if ($copfiltersettings{'CLAMD_BYTECODE_ENABLE'} eq '') { $copfiltersettings{'CLAMD_BYTECODE_ENABLE'} = 'on'; }
if ($copfiltersettings{'CLAMD_SAFEBROWSE_ENABLE'} eq '') { $copfiltersettings{'CLAMD_SAFEBROWSE_ENABLE'} = 'on'; }
if ($copfiltersettings{'CLAMD_PHISHING_SIGS'} eq '') { $copfiltersettings{'CLAMD_PHISHING_SIGS'} = 'off'; }
if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq '') { $copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_MAIL_NOTIF_ENABLE'} eq '') { $copfiltersettings{'THRDP_MAIL_NOTIF_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_ADD_HEADER_ENABLE'} eq '') { $copfiltersettings{'THRDP_ADD_HEADER_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_ADD_FOOTER_ENABLE'} eq '') { $copfiltersettings{'THRDP_ADD_FOOTER_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_PTANK_ENABLE'} eq '') { $copfiltersettings{'THRDP_PTANK_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SPAM_ENABLE'} eq '') { $copfiltersettings{'THRDP_SPAM_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_FILETYPE_ENABLE'} eq '') { $copfiltersettings{'THRDP_FILETYPE_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SPAMATTACH_ENABLE'} eq '') { $copfiltersettings{'THRDP_SPAMATTACH_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SECURITEINFO_ENABLE'} eq '') { $copfiltersettings{'THRDP_SECURITEINFO_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_WSPAM_ENABLE'} eq '') { $copfiltersettings{'THRDP_WSPAM_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_PORCUPINE_ENABLE'} eq '') { $copfiltersettings{'THRDP_PORCUPINE_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SPAMIMG_ENABLE'} eq '') { $copfiltersettings{'THRDP_SPAMIMG_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_HONEYNET_ENABLE'} eq '') { $copfiltersettings{'THRDP_HONEYNET_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_WPHSH_ENABLE'} eq '') { $copfiltersettings{'THRDP_WPHSH_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_WATTACH_ENABLE'} eq '') { $copfiltersettings{'THRDP_WATTACH_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_FOXGEN_ENABLE'} eq '') { $copfiltersettings{'THRDP_FOXGEN_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_FOXFILE_ENABLE'} eq '') { $copfiltersettings{'THRDP_FOXFILE_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_FOXALL_ENABLE'} eq '') { $copfiltersettings{'THRDP_FOXALL_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_LOTT_ENABLE'} eq '') { $copfiltersettings{'THRDP_LOTT_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SECINFOBAT_ENABLE'} eq '') { $copfiltersettings{'THRDP_SECINFOBAT_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_WMAL_ENABLE'} eq '') { $copfiltersettings{'THRDP_WMAL_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_WEXT_ENABLE'} eq '') { $copfiltersettings{'THRDP_WEXT_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_WBAD_ENABLE'} eq '') { $copfiltersettings{'THRDP_WBAD_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_CRDFAM_ENABLE'} eq '') { $copfiltersettings{'THRDP_CRDFAM_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_BOFPHSH_ENABLE'} eq '') { $copfiltersettings{'THRDP_BOFPHSH_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_BOFMAL_ENABLE'} eq '') { $copfiltersettings{'THRDP_BOFMAL_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_BOFATT_ENABLE'} eq '') { $copfiltersettings{'THRDP_BOFATT_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_BOFCRACK_ENABLE'} eq '') { $copfiltersettings{'THRDP_BOFCRACK_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SPEAR_ENABLE'} eq '') { $copfiltersettings{'THRDP_SPEAR_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SECINFOMARK_ENABLE'} eq '') { $copfiltersettings{'THRDP_SECINFOMARK_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SECINFODOS_ENABLE'} eq '') { $copfiltersettings{'THRDP_SECINFODOS_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SPEARL_ENABLE'} eq '') { $copfiltersettings{'THRDP_SPEARL_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SECINFOELF_ENABLE'} eq '') { $copfiltersettings{'THRDP_SECINFOELF_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_WPATT_ENABLE'} eq '') { $copfiltersettings{'THRDP_WPATT_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SECINFOHTM_ENABLE'} eq '') { $copfiltersettings{'THRDP_SECINFOHTM_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_MBL_ENABLE'} eq '') { $copfiltersettings{'THRDP_MBL_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_JURLBLA_ENABLE'} eq '') { $copfiltersettings{'THRDP_JURLBLA_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_JURLBL_ENABLE'} eq '') { $copfiltersettings{'THRDP_JURLBL_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_BLURL_ENABLE'} eq '') { $copfiltersettings{'THRDP_BLURL_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SCAMNAILER_ENABLE'} eq '') { $copfiltersettings{'THRDP_SCAMNAILER_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_JUNK_ENABLE'} eq '') { $copfiltersettings{'THRDP_JUNK_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SCAM_ENABLE'} eq '') { $copfiltersettings{'THRDP_SCAM_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SECINFOOFF_ENABLE'} eq '') { $copfiltersettings{'THRDP_SECINFOOFF_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SECINFOPDF_ENABLE'} eq '') { $copfiltersettings{'THRDP_SECINFOPDF_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_SECINFOSH_ENABLE'} eq '') { $copfiltersettings{'THRDP_SECINFOSH_ENABLE'} = 'off'; }
if ($copfiltersettings{'THRDP_PHISH_ENABLE'} eq '') { $copfiltersettings{'THRDP_PHISH_ENABLE'} = 'off'; }
if ($copfiltersettings{'CLAMD_BYTECODE_ENABLE'} eq '') { $copfiltersettings{'CLAMD_BYTECODE_ENABLE'} = 'on'; }
if ($copfiltersettings{'THRDP_ROGUE_ENABLE'} eq '') { $copfiltersettings{'THRDP_ROGUE_ENABLE'} = 'off'; }









#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("/var/ipcop/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();

my $CUR_VER = '';
my $CUR_MAIN = 0;
my $CUR_SUB1 = 0;
my $CUR_SUB2 = 0;
my $NEW_VER = '';
my $NEW_MAIN = 0;
my $NEW_SUB1 = 0;
my $NEW_SUB2 = 0;
my $UPDATE = 0;
my $THRDP = 0;



if ( system ("grep THRDP_VERSION= ${copfilter_swroot}/etc/global_settings >/dev/null 2>&1") eq 0 ){
$THRDP = 1;
$CUR_VER = `echo $copfiltersettings{'THRDP_VERSION'} | cut -d "b" -f1`;

if ( -e "${copfilter_swroot}/opt/clamav/var/log/LAST_852_VERSION" ){
	$NEW_VER = `cat "${copfilter_swroot}/opt/clamav/var/log/LAST_852_VERSION" | cut -d "b" -f1`;
}else{
	$NEW_VER = $CUR_VER;
}

$CUR_MAIN = `echo '$CUR_VER' | cut -d "." -f1`;
$CUR_SUB1 = `echo '$CUR_VER' | cut -d "." -f2`;
$CUR_SUB2 = `echo '$CUR_VER' | cut -d "." -f3`;

$NEW_MAIN = `echo '$NEW_VER' | cut -d "." -f1`;
$NEW_SUB1 = `echo '$NEW_VER' | cut -d "." -f2`;
$NEW_SUB2 = `echo '$NEW_VER' | cut -d "." -f3`;

	if ( $NEW_MAIN eq $CUR_MAIN ){
		if ( $NEW_SUB1 eq $CUR_SUB1 ){
			if ( $NEW_SUB2 gt $CUR_SUB2 ){
				$UPDATE = 1;
			}
		}elsif ( $NEW_SUB1 gt $CUR_SUB1 ){
			$UPDATE = 1;
		}
		}elsif ( $NEW_MAIN gt $CUR_MAIN ){
		$UPDATE = 1;
		}
}else{

	if ( system ("grep 'VERSION=2.1.92beta3' ${copfilter_swroot}/etc/global_settings >/dev/null 2>&1") eq 0 ){
		$THRDP = 1;
	}

	elsif ( system ("grep 'VERSION=2.1.92beta4' ${copfilter_swroot}/etc/global_settings >/dev/null 2>&1") eq 0 ){
		$THRDP = 1;
	}

	else {
		system('cat /var/log/copfilter/default/etc/global_settings | sed "s/^CLAMD_PHISHING_SIGS=.*$/CLAMD_PHISHING_SIGS=off/" > /tmp/global_settings');
		system('chown nobody.nobody /tmp/global_settings');
		system('mv -fT /tmp/global_settings /var/log/copfilter/default/etc/global_settings');
	}


}



################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_antivirus.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("/var/ipcop/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION-V2 HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}

sub count_files
{
    my $dir = shift;
    my $ext = shift;

    my ($count, $file);

    $count = 0;
    if (system ("ls " . $dir . " >>/tmp/count.aid 2>&1") eq 0 )
    {
       opendir(BIN, $dir) or die "Can't open $dir: $!";
       foreach my $file (grep {/\.$ext$/} readdir BIN)
       {
	    $count++;
	   
       }
       closedir(BIN);
    }
    else
    {
       print "<br /><P> $Lang::tr{'copfilter show quarantine error'} \n";
       print $dir . "</P>\n";
    }
    return $count;
}

sub count_files_type
{
    my $ext = shift;

    my ($dir_spam1, $dir_spam2);

    $dir_spam1 = "/var/log/copfilter/default/opt/p3scan/quarantine";
    $dir_spam2 = "/var/log/copfilter/default/opt/proxsmtp/quarantine";
    return count_files($dir_spam1, $ext) + count_files($dir_spam2, $ext);
}

sub count_virus()
{
    return count_files_type("virus");
}



my $nbr_virus = count_virus();




################################################################################
##   Antivirus, Antispam
################################################################################

######### CLAMD
$selected{'CLAMD_ENABLE'}{'off'} = '';
$selected{'CLAMD_ENABLE'}{'on'} = '';
$selected{'CLAMD_ENABLE'}{$copfiltersettings{'CLAMD_ENABLE'}} = "selected='selected'";

$selected{'CLAMD_BYTECODE_ENABLE'}{'off'} = '';
$selected{'CLAMD_BYTECODE_ENABLE'}{'on'} = '';
$selected{'CLAMD_BYTECODE_ENABLE'}{$copfiltersettings{'CLAMD_BYTECODE_ENABLE'}} = "selected='selected'";

$selected{'CLAMD_SAFEBROWSE_ENABLE'}{'off'} = '';
$selected{'CLAMD_SAFEBROWSE_ENABLE'}{'on'} = '';
$selected{'CLAMD_SAFEBROWSE_ENABLE'}{$copfiltersettings{'CLAMD_SAFEBROWSE_ENABLE'}} = "selected='selected'";

$selected{'CLAMD_UPDATE_METHOD'}{'manually'} = '';
$selected{'CLAMD_UPDATE_METHOD'}{'periodically'} = '';
$selected{'CLAMD_UPDATE_METHOD'}{$copfiltersettings{'CLAMD_UPDATE_METHOD'}} = "checked='checked'";

$selected{'CLAMD_UPDATE_PERIOD'}{'minutely'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{'daily'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'CLAMD_UPDATE_PERIOD'}{$copfiltersettings{'CLAMD_UPDATE_PERIOD'}} = "selected='selected'";

$selected{'CLAMD_VIRUS_EZIPS'}{'off'} = '';
$selected{'CLAMD_VIRUS_EZIPS'}{'on'} = '';
$selected{'CLAMD_VIRUS_EZIPS'}{$copfiltersettings{'CLAMD_VIRUS_EZIPS'}} = "selected='selected'";

$selected{'CLAMD_PHISHING_SIGS'}{'off'} = '';
$selected{'CLAMD_PHISHING_SIGS'}{'on'} = '';
$selected{'CLAMD_PHISHING_SIGS'}{$copfiltersettings{'CLAMD_PHISHING_SIGS'}} = "selected='selected'";

######### 3rd_party_sigs
$selected{'THRDP_MAIL_NOTIF_ENABLE'}{'off'} = '';
$selected{'THRDP_MAIL_NOTIF_ENABLE'}{'on'} = '';
$selected{'THRDP_MAIL_NOTIF_ENABLE'}{'error'} = '';
$selected{'THRDP_MAIL_NOTIF_ENABLE'}{$copfiltersettings{'THRDP_MAIL_NOTIF_ENABLE'}} = "selected='selected'";

$selected{'THRDP_ADD_HEADER_ENABLE'}{'off'} = '';
$selected{'THRDP_ADD_HEADER_ENABLE'}{'on'} = '';
$selected{'THRDP_ADD_HEADER_ENABLE'}{$copfiltersettings{'THRDP_ADD_HEADER_ENABLE'}} = "selected='selected'";

$selected{'THRDP_ADD_FOOTER_ENABLE'}{'off'} = '';
$selected{'THRDP_ADD_FOOTER_ENABLE'}{'on'} = '';
$selected{'THRDP_ADD_FOOTER_ENABLE'}{$copfiltersettings{'THRDP_ADD_FOOTER_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SHOW_GUI_ENABLE'}{'off'} = '';
$selected{'THRDP_SHOW_GUI_ENABLE'}{'on'} = '';
$selected{'THRDP_SHOW_GUI_ENABLE'}{$copfiltersettings{'THRDP_SHOW_GUI_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPAM_ENABLE'}{'off'} = '';
$selected{'THRDP_SPAM_ENABLE'}{'on'} = '';
$selected{'THRDP_SPAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPAM_ENABLE'}{$copfiltersettings{'THRDP_SPAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_FILETYPE_ENABLE'}{'off'} = '';
$selected{'THRDP_FILETYPE_ENABLE'}{'on'} = '';
$selected{'THRDP_FILETYPE_ENABLE'}{'havp'} = '';
$selected{'THRDP_FILETYPE_ENABLE'}{$copfiltersettings{'THRDP_FILETYPE_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECURITEINFO_ENABLE'}{'off'} = '';
$selected{'THRDP_SECURITEINFO_ENABLE'}{'on'} = '';
$selected{'THRDP_SECURITEINFO_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECURITEINFO_ENABLE'}{$copfiltersettings{'THRDP_SECURITEINFO_ENABLE'}} = "selected='selected'";

$selected{'THRDP_BOFATT_ENABLE'}{'off'} = '';
$selected{'THRDP_BOFATT_ENABLE'}{'on'} = '';
$selected{'THRDP_BOFATT_ENABLE'}{'havp'} = '';
$selected{'THRDP_BOFATT_ENABLE'}{$copfiltersettings{'THRDP_BOFATT_ENABLE'}} = "selected='selected'";

$selected{'THRDP_BOFCRACK_ENABLE'}{'off'} = '';
$selected{'THRDP_BOFCRACK_ENABLE'}{'on'} = '';
$selected{'THRDP_BOFCRACK_ENABLE'}{'havp'} = '';
$selected{'THRDP_BOFCRACK_ENABLE'}{$copfiltersettings{'THRDP_BOFCRACK_ENABLE'}} = "selected='selected'";

$selected{'THRDP_BOFMAL_ENABLE'}{'off'} = '';
$selected{'THRDP_BOFMAL_ENABLE'}{'on'} = '';
$selected{'THRDP_BOFMAL_ENABLE'}{'havp'} = '';
$selected{'THRDP_BOFMAL_ENABLE'}{$copfiltersettings{'THRDP_BOFMAL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_BOFPHSH_ENABLE'}{'off'} = '';
$selected{'THRDP_BOFPHSH_ENABLE'}{'on'} = '';
$selected{'THRDP_BOFPHSH_ENABLE'}{'havp'} = '';
$selected{'THRDP_BOFPHSH_ENABLE'}{$copfiltersettings{'THRDP_BOFPHSH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WSPAM_ENABLE'}{'off'} = '';
$selected{'THRDP_WSPAM_ENABLE'}{'on'} = '';
$selected{'THRDP_WSPAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_WSPAM_ENABLE'}{$copfiltersettings{'THRDP_WSPAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WATTACH_ENABLE'}{'off'} = '';
$selected{'THRDP_WATTACH_ENABLE'}{'on'} = '';
$selected{'THRDP_WATTACH_ENABLE'}{'havp'} = '';
$selected{'THRDP_WATTACH_ENABLE'}{$copfiltersettings{'THRDP_WATTACH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_PORCUPINE_ENABLE'}{'off'} = '';
$selected{'THRDP_PORCUPINE_ENABLE'}{'on'} = '';
$selected{'THRDP_PORCUPINE_ENABLE'}{'havp'} = '';
$selected{'THRDP_PORCUPINE_ENABLE'}{$copfiltersettings{'THRDP_PORCUPINE_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPAMIMG_ENABLE'}{'off'} = '';
$selected{'THRDP_SPAMIMG_ENABLE'}{'on'} = '';
$selected{'THRDP_SPAMIMG_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPAMIMG_ENABLE'}{$copfiltersettings{'THRDP_SPAMIMG_ENABLE'}} = "selected='selected'";

$selected{'THRDP_HONEYNET_ENABLE'}{'off'} = '';
$selected{'THRDP_HONEYNET_ENABLE'}{'on'} = '';
$selected{'THRDP_HONEYNET_ENABLE'}{'havp'} = '';
$selected{'THRDP_HONEYNET_ENABLE'}{$copfiltersettings{'THRDP_HONEYNET_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WPHSH_ENABLE'}{'off'} = '';
$selected{'THRDP_WPHSH_ENABLE'}{'on'} = '';
$selected{'THRDP_WPHSH_ENABLE'}{'havp'} = '';
$selected{'THRDP_WPHSH_ENABLE'}{$copfiltersettings{'THRDP_WPHSH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_PTANK_ENABLE'}{'off'} = '';
$selected{'THRDP_PTANK_ENABLE'}{'on'} = '';
$selected{'THRDP_PTANK_ENABLE'}{'havp'} = '';
$selected{'THRDP_PTANK_ENABLE'}{$copfiltersettings{'THRDP_PTANK_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOBAT_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOBAT_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOBAT_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOBAT_ENABLE'}{$copfiltersettings{'THRDP_SECINFOBAT_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WMAL_ENABLE'}{'off'} = '';
$selected{'THRDP_WMAL_ENABLE'}{'on'} = '';
$selected{'THRDP_WMAL_ENABLE'}{'havp'} = '';
$selected{'THRDP_WMAL_ENABLE'}{$copfiltersettings{'THRDP_WMAL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WEXT_ENABLE'}{'off'} = '';
$selected{'THRDP_WEXT_ENABLE'}{'on'} = '';
$selected{'THRDP_WEXT_ENABLE'}{'havp'} = '';
$selected{'THRDP_WEXT_ENABLE'}{$copfiltersettings{'THRDP_WEXT_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WBAD_ENABLE'}{'off'} = '';
$selected{'THRDP_WBAD_ENABLE'}{'on'} = '';
$selected{'THRDP_WBAD_ENABLE'}{'havp'} = '';
$selected{'THRDP_WBAD_ENABLE'}{$copfiltersettings{'THRDP_WBAD_ENABLE'}} = "selected='selected'";

$selected{'THRDP_FOXGEN_ENABLE'}{'off'} = '';
$selected{'THRDP_FOXGEN_ENABLE'}{'on'} = '';
$selected{'THRDP_FOXGEN_ENABLE'}{'havp'} = '';
$selected{'THRDP_FOXGEN_ENABLE'}{$copfiltersettings{'THRDP_FOXGEN_ENABLE'}} = "selected='selected'";

$selected{'THRDP_FOXFILE_ENABLE'}{'off'} = '';
$selected{'THRDP_FOXFILE_ENABLE'}{'on'} = '';
$selected{'THRDP_FOXFILE_ENABLE'}{'havp'} = '';
$selected{'THRDP_FOXFILE_ENABLE'}{$copfiltersettings{'THRDP_FOXFILE_ENABLE'}} = "selected='selected'";

$selected{'THRDP_FOXALL_ENABLE'}{'off'} = '';
$selected{'THRDP_FOXALL_ENABLE'}{'on'} = '';
$selected{'THRDP_FOXALL_ENABLE'}{'havp'} = '';
$selected{'THRDP_FOXALL_ENABLE'}{$copfiltersettings{'THRDP_FOXALL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_LOTT_ENABLE'}{'off'} = '';
$selected{'THRDP_LOTT_ENABLE'}{'on'} = '';
$selected{'THRDP_LOTT_ENABLE'}{'havp'} = '';
$selected{'THRDP_LOTT_ENABLE'}{$copfiltersettings{'THRDP_LOTT_ENABLE'}} = "selected='selected'";

$selected{'THRDP_CRDFAM_ENABLE'}{'off'} = '';
$selected{'THRDP_CRDFAM_ENABLE'}{'on'} = '';
$selected{'THRDP_CRDFAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_CRDFAM_ENABLE'}{$copfiltersettings{'THRDP_CRDFAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFODOS_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFODOS_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFODOS_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFODOS_ENABLE'}{$copfiltersettings{'THRDP_SECINFODOS_ENABLE'}} = "selected='selected'";

$selected{'THRDP_WPATT_ENABLE'}{'off'} = '';
$selected{'THRDP_WPATT_ENABLE'}{'on'} = '';
$selected{'THRDP_WPATT_ENABLE'}{'havp'} = '';
$selected{'THRDP_WPATT_ENABLE'}{$copfiltersettings{'THRDP_WPATT_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPAMATTACH_ENABLE'}{'off'} = '';
$selected{'THRDP_SPAMATTACH_ENABLE'}{'on'} = '';
$selected{'THRDP_SPAMATTACH_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPAMATTACH_ENABLE'}{$copfiltersettings{'THRDP_SPAMATTACH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPEAR_ENABLE'}{'off'} = '';
$selected{'THRDP_SPEAR_ENABLE'}{'on'} = '';
$selected{'THRDP_SPEAR_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPEAR_ENABLE'}{$copfiltersettings{'THRDP_SPEAR_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOMARK_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOMARK_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOMARK_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOMARK_ENABLE'}{$copfiltersettings{'THRDP_SECINFOMARK_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOELF_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOELF_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOELF_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOELF_ENABLE'}{$copfiltersettings{'THRDP_SECINFOELF_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SPEARL_ENABLE'}{'off'} = '';
$selected{'THRDP_SPEARL_ENABLE'}{'on'} = '';
$selected{'THRDP_SPEARL_ENABLE'}{'havp'} = '';
$selected{'THRDP_SPEARL_ENABLE'}{$copfiltersettings{'THRDP_SPEARL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_JURLBL_ENABLE'}{'off'} = '';
$selected{'THRDP_JURLBL_ENABLE'}{'on'} = '';
$selected{'THRDP_JURLBL_ENABLE'}{'havp'} = '';
$selected{'THRDP_JURLBL_ENABLE'}{$copfiltersettings{'THRDP_JURLBL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_JUNK_ENABLE'}{'off'} = '';
$selected{'THRDP_JUNK_ENABLE'}{'on'} = '';
$selected{'THRDP_JUNK_ENABLE'}{'havp'} = '';
$selected{'THRDP_JUNK_ENABLE'}{$copfiltersettings{'THRDP_JUNK_ENABLE'}} = "selected='selected'";

$selected{'THRDP_MBL_ENABLE'}{'off'} = '';
$selected{'THRDP_MBL_ENABLE'}{'on'} = '';
$selected{'THRDP_MBL_ENABLE'}{'havp'} = '';
$selected{'THRDP_MBL_ENABLE'}{$copfiltersettings{'THRDP_MBL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOHTM_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOHTM_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOHTM_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOHTM_ENABLE'}{$copfiltersettings{'THRDP_SECINFOHTM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SCAMNAILER_ENABLE'}{'off'} = '';
$selected{'THRDP_SCAMNAILER_ENABLE'}{'on'} = '';
$selected{'THRDP_SCAMNAILER_ENABLE'}{'havp'} = '';
$selected{'THRDP_SCAMNAILER_ENABLE'}{$copfiltersettings{'THRDP_SCAMNAILER_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOOFF_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOOFF_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOOFF_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOOFF_ENABLE'}{$copfiltersettings{'THRDP_SECINFOOFF_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOSH_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOSH_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOSH_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOSH_ENABLE'}{$copfiltersettings{'THRDP_SECINFOSH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SCAM_ENABLE'}{'off'} = '';
$selected{'THRDP_SCAM_ENABLE'}{'on'} = '';
$selected{'THRDP_SCAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_SCAM_ENABLE'}{$copfiltersettings{'THRDP_SCAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_SECINFOPDF_ENABLE'}{'off'} = '';
$selected{'THRDP_SECINFOPDF_ENABLE'}{'on'} = '';
$selected{'THRDP_SECINFOPDF_ENABLE'}{'havp'} = '';
$selected{'THRDP_SECINFOPDF_ENABLE'}{$copfiltersettings{'THRDP_SECINFOPDF_ENABLE'}} = "selected='selected'";

$selected{'THRDP_PHISH_ENABLE'}{'off'} = '';
$selected{'THRDP_PHISH_ENABLE'}{'on'} = '';
$selected{'THRDP_PHISH_ENABLE'}{'havp'} = '';
$selected{'THRDP_PHISH_ENABLE'}{$copfiltersettings{'THRDP_PHISH_ENABLE'}} = "selected='selected'";

$selected{'THRDP_BLURL_ENABLE'}{'off'} = '';
$selected{'THRDP_BLURL_ENABLE'}{'on'} = '';
$selected{'THRDP_BLURL_ENABLE'}{'havp'} = '';
$selected{'THRDP_BLURL_ENABLE'}{$copfiltersettings{'THRDP_BLURL_ENABLE'}} = "selected='selected'";

$selected{'THRDP_LW_SCAM_ENABLE'}{'off'} = '';
$selected{'THRDP_LW_SCAM_ENABLE'}{'on'} = '';
$selected{'THRDP_LW_SCAM_ENABLE'}{'havp'} = '';
$selected{'THRDP_LW_SCAM_ENABLE'}{$copfiltersettings{'THRDP_LW_SCAM_ENABLE'}} = "selected='selected'";

$selected{'THRDP_ROGUE_ENABLE'}{'off'} = '';
$selected{'THRDP_ROGUE_ENABLE'}{'on'} = '';
$selected{'THRDP_ROGUE_ENABLE'}{'havp'} = '';
$selected{'THRDP_ROGUE_ENABLE'}{$copfiltersettings{'THRDP_ROGUE_ENABLE'}} = "selected='selected'";

$selected{'THRDP_LW_IMAGE_ENABLE'}{'off'} = '';
$selected{'THRDP_LW_IMAGE_ENABLE'}{'on'} = '';
$selected{'THRDP_LW_IMAGE_ENABLE'}{'havp'} = '';
$selected{'THRDP_LW_IMAGE_ENABLE'}{$copfiltersettings{'THRDP_LW_IMAGE_ENABLE'}} = "selected='selected'";

$selected{'THRDP_JURLBLA_ENABLE'}{'off'} = '';
$selected{'THRDP_JURLBLA_ENABLE'}{'on'} = '';
$selected{'THRDP_JURLBLA_ENABLE'}{'havp'} = '';
$selected{'THRDP_JURLBLA_ENABLE'}{$copfiltersettings{'THRDP_JURLBLA_ENABLE'}} = "selected='selected'";

######### FPROT
$selected{'FPROT_ENABLE'}{'off'} = '';
$selected{'FPROT_ENABLE'}{'on'} = '';
$selected{'FPROT_ENABLE'}{$copfiltersettings{'FPROT_ENABLE'}} = "selected='selected'";

$selected{'FPROT_UPDATE_METHOD'}{'manually'} = '';
$selected{'FPROT_UPDATE_METHOD'}{'periodically'} = '';
$selected{'FPROT_UPDATE_METHOD'}{$copfiltersettings{'FPROT_UPDATE_METHOD'}} = "checked='checked'";

$selected{'FPROT_UPDATE_PERIOD'}{'minutely'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{'daily'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'FPROT_UPDATE_PERIOD'}{$copfiltersettings{'FPROT_UPDATE_PERIOD'}} = "selected='selected'";


######### AVG
$selected{'AVG_ENABLE'}{'off'} = '';
$selected{'AVG_ENABLE'}{'on'} = '';
$selected{'AVG_ENABLE'}{$copfiltersettings{'AVG_ENABLE'}} = "selected='selected'";

$selected{'AVG_UPDATE_METHOD'}{'manually'} = '';
$selected{'AVG_UPDATE_METHOD'}{'periodically'} = '';
$selected{'AVG_UPDATE_METHOD'}{$copfiltersettings{'AVG_UPDATE_METHOD'}} = "checked='checked'";

$selected{'AVG_UPDATE_PERIOD'}{'minutely'} = '';
$selected{'AVG_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'AVG_UPDATE_PERIOD'}{'daily'} = '';
$selected{'AVG_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'AVG_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'AVG_UPDATE_PERIOD'}{$copfiltersettings{'AVG_UPDATE_PERIOD'}} = "selected='selected'";


######### AVAST
$selected{'AVAST_ENABLE'}{'off'} = '';
$selected{'AVAST_ENABLE'}{'on'} = '';
$selected{'AVAST_ENABLE'}{$copfiltersettings{'AVAST_ENABLE'}} = "selected='selected'";

$selected{'AVAST_UPDATE_METHOD'}{'manually'} = '';
$selected{'AVAST_UPDATE_METHOD'}{'periodically'} = '';
$selected{'AVAST_UPDATE_METHOD'}{$copfiltersettings{'AVAST_UPDATE_METHOD'}} = "checked='checked'";

$selected{'AVAST_UPDATE_PERIOD'}{'minutely'} = '';
$selected{'AVAST_UPDATE_PERIOD'}{'hourly'} = '';
$selected{'AVAST_UPDATE_PERIOD'}{'daily'} = '';
$selected{'AVAST_UPDATE_PERIOD'}{'weekly'} = '';
$selected{'AVAST_UPDATE_PERIOD'}{'monthly'} = '';
$selected{'AVAST_UPDATE_PERIOD'}{$copfiltersettings{'AVAST_UPDATE_PERIOD'}} = "selected='selected'";



################################################################################
##   ACTIONs
################################################################################


if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter clamd update now'})
{
        system ('/usr/local/bin/copfilter_check-updates_clamav 2>&1 |logger -t "copfilter clamd update now" &');
        system ('/usr/bin/touch', "${copfilter_swroot}/etc/copfilter_check-updates_clamav.done");
        $copfiltersettings{'ACTION'} = '';
}


if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter fprot update now'})
{
        system ('/usr/local/bin/copfilter_check-updates_f-prot 2>&1 |logger -t "copfilter fprot update now" &');
        system ('/usr/bin/touch', "${copfilter_swroot}/etc/copfilter_check-updates_f-prot.done");
        $copfiltersettings{'ACTION'} = '';
}


if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter avg update now'})
{
        system ('/usr/local/bin/copfilter_check-updates_avg 2>&1 |logger -t "copfilter avg update now" &');
        system ('/usr/bin/touch', "${copfilter_swroot}/etc/copfilter_check-updates_avg.done");
        $copfiltersettings{'ACTION'} = '';
}


if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter avast update now'})
{
        system ('/usr/local/bin/copfilter_check-updates_avast 2>&1 |logger -t "copfilter avast update now" &');
        system ('/usr/bin/touch', "${copfilter_swroot}/etc/copfilter_check-updates_avast.done");
        $copfiltersettings{'ACTION'} = '';
}




######### send quarantined email
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter send q_mail'} )
{
        &copfilter_start_log();
        &writehashsorted("/tmp/env_send_q_mail.tmp", \%copfiltersettings);
        system ('/usr/local/bin/copfilter_send_q_mail');
        &copfilter_stop_log();
}




use File::stat;
use Time::localtime;



####################################
# Sort Virus Quarantine
# by copfilter forum user Taurus
# http://copfilter.endlich-mail.de/viewtopic.php?t=1307
#
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_subject'} )
{
	$sortorder = 1;
	$copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_date'} )
{
  $sortorder = 2;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}

if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_from'} )
{
  $sortorder = 3;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_to'} )
{
  $sortorder = 4;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter v_virusname'} )
{
  $sortorder = 5;
  $copfiltersettings{'ACTION'} = $Lang::tr{'copfilter show virus quarantine'};
}




######### Show virus quarantine

if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter show virus quarantine'} )
{
        &copfilter_start_log();

if (system ("ls /var/log/copfilter/default/opt/p3scan/quarantine >/dev/null 2>&1") eq 0 )
{
my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2, @fileliste, @scoreliste, $index1, $nrofspams, $score, $help1, $date3, $sortorder1, $testvar, $testvar2, $virusname, $virusfilename);
#my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
$dir = "/var/log/copfilter/default/opt/p3scan/quarantine";
print "<br />\n";
print "<b>$Lang::tr{'copfilter show virus quarantine'} - POP3 - $dir</b>\n";
print "<br><br>";
print "<form method='post' action='/cgi-bin/copfilter_antivirus.cgi' enctype='multipart/form-data'>\n";
print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
print "<TR>\n";
print "<td align='center'>del</td>\n";
print "<td align='center'>send</td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_from'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_to'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_subject'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter v_virusname'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_virusname'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_date'}'   </td>\n";
print "<td align='center'> $Lang::tr{'copfilter v_filename'} </td>\n";
#print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_filename'}'   </td>\n";
print "</TR>\n";

#######################
# Sort
$index1 = 0;
opendir(BIN, $dir) or die "Can't open $dir: $!";
foreach my $file (grep {/\.virus$/} readdir BIN){
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
        if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
	 if (($recipient eq "") and (/^To: /i)) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }

	 if (($subject eq "") and (/^Subject: /i)) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
#      $recipient2 =  substr($recipient, 0, 30);
      $recipient2 =  substr($recipient, 0, 30);
#      if ($recipient2 == "") {$recipient2="aaa";}
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);

      $tm = localtime($sec);
      $date3=sprintf("%04d-%02d-%02d  %02d:%02d:%02d\n",
        $tm->year+1900, $tm->mon+1, $tm->mday,
        $tm->hour, $tm->min, $tm->sec);
   }
#   	 print "<";
#	 print $score;
#	 print "> \n";
    if ($recipient2 eq "") {$recipient2="                       ";}
####  
# Add leading Zeros, not nice - but works ;-)
#  if (index($score,".") < 2){$score="0".$score;}
#  if (index($score,".") < 3){$score="0".$score;}
# $sortorder bestimmt die Sortierung:
# 1 - sortiert nach Subject (aufsteigend)
# 2 - sortiert nach Datum (aufsteigend)  
# 3 - sortiert nach From(aufsteigend)  
# 4 - sortiert nach To(aufsteigend)  
# 5 - sortiert nach Virusname
# 
#  $sortorder1=$sortorder & 127;
   $sortorder1=$sortorder;
# 
#
      $virusfilename = "$dir/$file\.name";        # Name the file

      open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file


  if ($sortorder1 == 1) { $scoreliste[$index1]=$subject."|".$file; }
  if ($sortorder1 == 2) { 
#    $help1=substr($date3,0,8);
    $help1=substr($date3,0,18);
    $scoreliste[$index1]=$help1."|".$file; 
  }
  if ($sortorder1 == 3) { $scoreliste[$index1]=$sender2."|".$file; }
 if ($sortorder1 == 4) { 
   #
   $recipient2=~ s/<//;
   $recipient2=~ s/>//;
   $recipient2=~ s/\012//;
   $recipient2=~ s/,//;
   $recipient2=~ s/ //g;
   $scoreliste[$index1]=$recipient2."|".$file; 
 }
 if ($sortorder1 == 5) { $scoreliste[$index1]=$virusname."|".$file; }
#     	 print "<";
#	 print $scoreliste[$index1];
#	 print "> \n";
  $index1++;
}
closedir(BIN);  
$nrofspams=$index1;
#print "-----------------------------------------";
$index1=0;
while ($index1 < $nrofspams){

 # print "$scoreliste[$index1]<TR>\n";
  $index1++;

}


@fileliste=sort{$a cmp $b} @scoreliste;
#if ($sortorder > 128){@fileliste=reverse(@fileliste);}

#print "---------------SORTED--------------------------";


#####################################################
#opendir(BIN, $dir) or die "Can't open $dir: $!";
#while( defined ($file = readdir(BIN))) {
$index1=0;
while ($index1 < $nrofspams){
   $help1=$fileliste[$index1];
   #
   # !!!
   #
   $file=substr($help1,index($help1,"|")+1,255);
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
#!!!   $hit = 1 if -T "$dir/$file";
   $hit = 1;
   if ($hit == 1) {
      open (EP,"<$dir/$file") or print "open failed";
      while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;

#            $_ =~ s/$1/.+<from:(.+)>/i;
#            $_ =~ s/.*(([A-Z0-9]+[._]?){1,}[A-Z0-9]+\@(([A-Z0-9]+[-]?){1,}[A-Z0-9]+\.){1,}[A-Z]{2,4}).*/$1/i;
#            $_ =~ s/.*(@).*/$1/i;
#            $_ =~ s/.*(\b\[A-Z0-9._%-\]++@\[A-Z0-9._%-\]+\.\[A-Z\]\{2,4\}\b).*/$1/i;
#            $_ =~ s/[ .><]*([0-9a-zA-Z-.]+\@[-.\w]+\.\w{2,3}\W)[ <>.]*/$1/i;
##             $_ = ~ /^From:\s([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)$/

            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
         if (/^Subject: /i) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
      $recipient2 =  substr($recipient, 0, 30);
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);
      print "<TR>\n";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
      print "<td class='base' align='left'>$sender2</td>";
      print "<td class='base' align='left'>$recipient2</td>";
      print "<td class='base' align='left'>$subject2</td>";
      print "<td class='base' align='left'>";

      $virusfilename = "$dir/$file\.name";        # Name the file

     open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file
      print $virusname;         # Print the array

      print "</td>";
      print "<td class='base' align='left'>";

      $tm = localtime($sec);
      printf("%04d-%02d-%02d  %02d:%02d:%02d\n",
      $tm->year+1900, $tm->mon+1, $tm->mday,
      $tm->hour, $tm->min, $tm->sec);
      print "</td>";
      print "<td class='base' align='left'><a href='/p3scan_quarantine/$file' target='_blank'>$file2</a></td>";
      print "</TR>";

   }
   $index1++;
}
closedir(BIN);
        print "</table>";

}
else
{
print "<br /><P> $Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/p3scan/quarantine</P>\n";
}

print "<br />\n";
print "<br />\n";
print "<br />\n";


if ( system ("ls /var/log/copfilter/default/opt/proxsmtp/quarantine >/dev/null 2>&1") eq 0 )
{
my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2, @fileliste, @scoreliste, $index1, $nrofspams, $score, $help1, $date3, $sortorder1, $testvar, $testvar2, $virusname, $virusfilename);
#my ($dir, $file, $file2, $hit, $subject, $subject2, $sender, $sender2, $recipient, $recipient2, $date, $date2);
$dir = "/var/log/copfilter/default/opt/proxsmtp/quarantine";
print "<b>$Lang::tr{'copfilter show virus quarantine'} - SMTP - $dir</b>\n";
print "<br><br>";
print "<table width='100%' cellpadding='2' cellspacing='0' color='#ffffff' border='1'>\n";
print "<TR>\n";
print "<td align='center'>del</td>\n";
print "<td align='center'>send</td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_from'}      </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_from'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_to'}       </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_to'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_subject'}  </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_subject'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter v_virusname'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_virusname'}'   </td>\n";
#print "<td align='center'> $Lang::tr{'copfilter q_date'}     </td>\n";
print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_date'}'   </td>\n";
print "<td align='center'> $Lang::tr{'copfilter v_filename'} </td>\n";
#print "<td align='center'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter v_filename'}'   </td>\n";
print "</TR>\n";

#######################
# Sort
$index1 = 0;
opendir(BIN, $dir) or die "Can't open $dir: $!";
foreach my $file (grep {/\.virus$/} readdir BIN){
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
   if ($hit == 1) {
      open (EP,"$dir/$file");
      while (<EP>) {
        if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;
            $sender = $_;
         }
#         if (/Envelope-To:/i) {
	 if (($recipient eq "") and (/^To: /i)) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }

	 if (($subject eq "") and (/^Subject: /i)) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }

      }

#      printf("%02d.%02d.%04d-%02d:%02d:%02d\n",
#      $tm->mday, $tm->mon+1, $tm->year+1900,
#      $tm->hour, $tm->min, $tm->sec);

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
#      $recipient2 =  substr($recipient, 0, 30);
      $recipient2 =  substr($recipient, 0, 30);
#      if ($recipient2 == "") {$recipient2="aaa";}
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 13);

      $tm = localtime($sec);
      $date3=sprintf("%04d%02d%02d_%02d:%02d:%02d\n",
        $tm->year+1900, $tm->mon+1, $tm->mday,
        $tm->hour, $tm->min, $tm->sec);
   }
#   	 print "<";
#	 print $score;
#	 print "> \n";
    if ($recipient2 eq "") {$recipient2="                       ";}
####  
# Add leading Zeros, not nice - but works ;-)
#  if (index($score,".") < 2){$score="0".$score;}
#  if (index($score,".") < 3){$score="0".$score;}
# $sortorder bestimmt die Sortierung:
# 1 - sortiert nach Subject (aufsteigend)
# 2 - sortiert nach Datum (aufsteigend)  
# 3 - sortiert nach From(aufsteigend)  
# 4 - sortiert nach To(aufsteigend)  
# 5 - sortiert nach Virusname
# 
#  $sortorder1=$sortorder & 127;
   $sortorder1=$sortorder;
# 
#
      $virusfilename = "$dir/$file\.name";        # Name the file

      open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file

  if ($sortorder1 == 1) { $scoreliste[$index1]=$subject."|".$file; }
  if ($sortorder1 == 2) { 
    $help1=substr($date3,0,8);
    $scoreliste[$index1]=$help1."|".$file; 
  }
  if ($sortorder1 == 3) { $scoreliste[$index1]=$sender2."|".$file; }
 if ($sortorder1 == 4) { 
   #
   $recipient2=~ s/<//;
   $recipient2=~ s/>//;
   $recipient2=~ s/\012//;
   $recipient2=~ s/,//;
   $recipient2=~ s/ //g;
   $scoreliste[$index1]=$recipient2."|".$file; 
 }
  if ($sortorder1 == 5) { $scoreliste[$index1]=$virusname."|".$file; }
#     	 print "<";
#	 print $scoreliste[$index1];
#	 print "> \n";
  $index1++;
}
closedir(BIN);  
$nrofspams=$index1;
#print "-----------------------------------------";
$index1=0;
while ($index1 < $nrofspams){

 # print "$scoreliste[$index1]<TR>\n";
  $index1++;

}


@fileliste=sort{$a cmp $b} @scoreliste;
#if ($sortorder > 128){@fileliste=reverse(@fileliste);}

#print "---------------SORTED--------------------------";


#####################################################
#opendir(BIN, $dir) or die "Can't open $dir: $!";
#while( defined ($file = readdir(BIN))) {
$index1=0;
while ($index1 < $nrofspams){
   $help1=$fileliste[$index1];
   #
   # !!!
   #
   $file=substr($help1,index($help1,"|")+1,255);
   $hit = 0;
   $subject = "";
   $subject2 = "";
   $sender = "";
   $recipient = "";
   $date = "";
   $hit = 1 if -T "$dir/$file";
#!!!   $hit = 1 if -T "$dir/$file";
       if ($hit == 1) {
          open (EP,"$dir/$file");
          while (<EP>) {
         if (/^From: /i) {
            $_ =~ s/.+<(.+)>/$1/i;

#            $_ =~ s/$1/.+<from:(.+)>/i;
#            $_ =~ s/.*(([A-Z0-9]+[._]?){1,}[A-Z0-9]+\@(([A-Z0-9]+[-]?){1,}[A-Z0-9]+\.){1,}[A-Z]{2,4}).*/$1/i;
#            $_ =~ s/.*(@).*/$1/i;
#            $_ =~ s/.*(\b\[A-Z0-9._%-\]++@\[A-Z0-9._%-\]+\.\[A-Z\]\{2,4\}\b).*/$1/i;
#            $_ =~ s/[ .><]*([0-9a-zA-Z-.]+\@[-.\w]+\.\w{2,3}\W)[ <>.]*/$1/i;
##             $_ = ~ /^From:\s([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)$/

            $sender = $_;
         }
#         if (/Envelope-To:/i) {
         if (/^To: /i) {
#            $_ =~ s/.+<(.+)>/$1/i;
#            $_ =~ s/$1/<to:(.+)>/i;

            $_ =~ s/.+<(.+)>/$1/i;
            $_ =~ s/to:(.+)/$1/i;
            $recipient = $_;
         }
         if (/^Subject: /i) {
            $_ =~ s/subject:(.+)/$1/i;
            $subject = $_;
         }
         if (/Date:/i) {
            $_ =~ s/date:(.+)/$1/i;
            $date = $_;
         }


          }

      my ($sec, $tm);
      $sec = stat("$dir/$file")->mtime;

      $sender2 =  substr($sender, 0, 30);
      $subject2 =  substr($subject, 0, 70);
      $recipient2 =  substr($recipient, 0, 30);
      $date2 =  substr($date, 6, 21);
      $file2 =  substr($file, 0, 16);
      print "<TR>\n";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file.delete' /></td>";
      print "<td class='base' align='center'><input type='checkbox' name='$dir/$file' /></td>";
      print "<td class='base' align='left'>$sender2</td>";
      print "<td class='base' align='left'>$recipient2</td>";
      print "<td class='base' align='left'>$subject2</td>";
      print "<td class='base' align='left'>";

      $virusfilename = "$dir/$file\.name";        # Name the file

      open(VIRUSNAME, $virusfilename);        # Open the file
      $virusname = <VIRUSNAME>;      # Read it into an array
      close(VIRUSNAME);          # Close the file
      print $virusname;         # Print the array

      print "</td>";
      print "<td class='base' align='left'>";

      $tm = localtime($sec);
      printf("%04d-%02d-%02d  %02d:%02d:%02d\n",
      $tm->year+1900, $tm->mon+1, $tm->mday,
      $tm->hour, $tm->min, $tm->sec);
      print "</td>";
      print "<td class='base' align='left'><a href='/proxsmtp_quarantine/$file' target='_blank'>$file2</a></td>";
      print "</TR>";

       }
   $index1++;
    }
    closedir(BIN);

    print <<END
    </table><br /><br />

    <table border='0'>
    <tr><td> del ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail6'}</td></tr>
    <tr><td> send ... </td><td>&nbsp; $Lang::tr{'copfilter send q_mail4'}</td></tr>
    </table><br /><br />

    <table border='0'>
    <tr><td>
           <input type='checkbox' name='DELETE_ALL_VIRUS' /> $Lang::tr{'copfilter send q_mail2'}
       </td>
    </tr>

    <tr><td>
            &nbsp;
       </td>
    </tr>

    <tr><td>
           <input type='submit' name='ACTION' value='$Lang::tr{'copfilter send q_mail'}' />
       </td>

       <td width=15 >
            &nbsp;
       </td>
    </tr>
    </table>
    </form>

END
;


}
else
{
print "<br /><P>$Lang::tr{'copfilter show quarantine error'} \n";
print "/var/log/copfilter/default/opt/proxsmtp/quarantine</P>\n";
}
        &copfilter_stop_log();
}






######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{ 

################################################################################
##   Checking input values
################################################################################
############ 3rd_party_sigs start #####################

if ($copfiltersettings{'CLAMD_PHISHING_SIGS'} eq 'on' ) {
	 if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'THRDP_MAIL_NOTIF_ENABLE'} !~ /^(on|off|error)$/ || 
	    $copfiltersettings{'THRDP_ADD_HEADER_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'THRDP_ADD_FOOTER_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'THRDP_PTANK_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_FILETYPE_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPAMATTACH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECURITEINFO_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WSPAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_PORCUPINE_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPAMIMG_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_HONEYNET_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WPHSH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WATTACH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_FOXGEN_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_FOXFILE_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_FOXALL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_LOTT_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOBAT_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WMAL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WEXT_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WBAD_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_CRDFAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_BOFPHSH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_BOFMAL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_BOFATT_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_BOFCRACK_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPEAR_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOMARK_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFODOS_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SPEARL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOELF_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_WPATT_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOHTM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_MBL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_JURLBLA_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_JURLBL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_BLURL_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SCAMNAILER_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_JUNK_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SCAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOOFF_ENABLE'} !~ /^(on|off|havp)$/ || 
#	    $copfiltersettings{'THRDP_LW_SCAM_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOPDF_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_SECINFOSH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_PHISH_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'CLAMD_BYTECODE_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_SAFEBROWSE_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'THRDP_ROGUE_ENABLE'} !~ /^(on|off|havp)$/ || 
	    $copfiltersettings{'THRDP_ROGUE_ENABLE'} !~ /^(on|off|havp)$/) 
#	    $copfiltersettings{'THRDP_LW_IMAGE_ENABLE'} !~ /^(on|off|havp)$/)
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 
}

############ 3rd_party_sigs end #####################


	    if ($copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ ||
	    $copfiltersettings{'AVG_ENABLE'} !~ /^(on|off)$/ ) 
        {
		$errormessage = $Lang::tr{'copfilter invalid input'};
		goto ERROR;
	} 

        if (!($copfiltersettings{'CLAMD_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'CLAMD_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid clamd time period'};
                goto ERROR;
        }


        if (!($copfiltersettings{'FPROT_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'FPROT_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid fprot time period'};
                goto ERROR;
        }


        if (!($copfiltersettings{'AVG_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'AVG_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid avg time period'};
                goto ERROR;
        }
        if (!($copfiltersettings{'AVAST_UPDATE_VALUE'} =~ /^\d+$/) || $copfiltersettings{'AVAST_UPDATE_VALUE'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid avast time period'};
                goto ERROR;
        }



ERROR:
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
              	$copfiltersettings{'VALID'} = 'yes'; }



################################################################################
##   set update values
################################################################################


        # CLAMAV
        my ($clamd_updateperiod)=();

        if  ($copfiltersettings{'CLAMD_UPDATE_PERIOD'} eq 'hourly') {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 60; }
        elsif  ($copfiltersettings{'CLAMD_UPDATE_PERIOD'} eq 'daily') {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'CLAMD_UPDATE_PERIOD'} eq 'weekly') {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'CLAMD_UPDATE_PERIOD'} eq 'monthly') {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 40320; }
        else {
        	$clamd_updateperiod = $copfiltersettings{'CLAMD_UPDATE_VALUE'} * 1; }

        $clamd_updateperiod = $clamd_updateperiod - 5;

        if ($clamd_updateperiod <= 5) {
        	$clamd_updateperiod = 5; }

        open(FILE, ">/${copfilter_swroot}/etc/clamd_counter.conf") or die $Lang::tr{'copfilter clamd_counter'};
        flock(FILE, 2);
        print FILE "$clamd_updateperiod\n";
        close FILE;


        # F-PROT
        my ($fprot_updateperiod)=();

        if  ($copfiltersettings{'FPROT_UPDATE_PERIOD'} eq 'hourly') {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 60; }
        elsif  ($copfiltersettings{'FPROT_UPDATE_PERIOD'} eq 'daily') {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'FPROT_UPDATE_PERIOD'} eq 'weekly') {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'FPROT_UPDATE_PERIOD'} eq 'monthly') {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 40320; }
        else {
        	$fprot_updateperiod = $copfiltersettings{'FPROT_UPDATE_VALUE'} * 1; }

        $fprot_updateperiod = $fprot_updateperiod - 5;

        if ($fprot_updateperiod <= 5) {
        	$fprot_updateperiod = 5; }

        open(FILE, ">/${copfilter_swroot}/etc/fprot_counter.conf") or die $Lang::tr{'copfilter fprot_counter'};
        flock(FILE, 2);
        print FILE "$fprot_updateperiod\n";
        close FILE;


        # AVG
        my ($avg_updateperiod)=();

        if  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'hourly') {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 60; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'daily') {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'weekly') {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'monthly') {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 40320; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'minutely') {
        	$avg_updateperiod = $copfiltersettings{'AVG_UPDATE_VALUE'} * 1; }

        $avg_updateperiod = $avg_updateperiod - 5;

        if ($avg_updateperiod <= 5) {
        	$avg_updateperiod = 5; }

        open(FILE, ">/${copfilter_swroot}/etc/avg_counter.conf") or die $Lang::tr{'copfilter avg_counter'};
        flock(FILE, 2);
        print FILE "$avg_updateperiod\n";
        close FILE;


        # AVAST
        my ($avast_updateperiod)=();

        if  ($copfiltersettings{'AVAST_UPDATE_PERIOD'} eq 'hourly') {
        	$avast_updateperiod = $copfiltersettings{'AVAST_UPDATE_VALUE'} * 60; }
        elsif  ($copfiltersettings{'AVAST_UPDATE_PERIOD'} eq 'daily') {
        	$avast_updateperiod = $copfiltersettings{'AVAST_UPDATE_VALUE'} * 1440; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'weekly') {
        	$avast_updateperiod = $copfiltersettings{'AVAST_UPDATE_VALUE'} * 10080; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'monthly') {
        	$avast_updateperiod = $copfiltersettings{'AVAST_UPDATE_VALUE'} * 40320; }
        elsif  ($copfiltersettings{'AVG_UPDATE_PERIOD'} eq 'minutely') {
        	$avast_updateperiod = $copfiltersettings{'AVAST_UPDATE_VALUE'} * 1; }

        $avast_updateperiod = $avast_updateperiod - 5;

        if ($avast_updateperiod <= 5) {
        	$avast_updateperiod = 5; }

        open(FILE, ">/${copfilter_swroot}/etc/avavast_counter.conf") or die $Lang::tr{'copfilter avast_counter'};
        flock(FILE, 2);
        print FILE "$avast_updateperiod\n";
        close FILE;


################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

	    unlink "${copfilter_swroot}/etc/clamd_enable";
	    unlink "${copfilter_swroot}/etc/fprotd_enable";
	    unlink "${copfilter_swroot}/etc/avg_enable";

       	    if ($copfiltersettings{'CLAMD_ENABLE'} eq 'on') {
			system ('/usr/bin/touch', "${copfilter_swroot}/etc/clamd_enable"); }


           if ( -e "${copfilter_swroot}/opt/avg/default/bin/avgscan") {
#            if ( -e "/opt/avg/av/bin/avgscan") {

                if ($copfiltersettings{'AVG_ENABLE'} eq 'on') {
                system ('/usr/bin/touch', "${copfilter_swroot}/etc/avg_enable"); }
            }


            if ( -e "${copfilter_swroot}/opt/avast/default/avast") {
                if ($copfiltersettings{'AVAST_ENABLE'} eq 'on') {
                system ('/usr/bin/touch', "${copfilter_swroot}/etc/avast_enable"); }
            }



            if ( -e "${copfilter_swroot}/opt/f-prot/default/fpscan") {
                if ($copfiltersettings{'FPROT_ENABLE'} eq 'on') {
                system ('/usr/bin/touch', "${copfilter_swroot}/etc/fprotd_enable"); }
            }


           if ( ! -e "${copfilter_swroot}/etc/clamd_counter") {
                if ($copfiltersettings{'CLAMD_UPDATE_METHOD'} eq 'periodically')
                {
                        open(FILE, ">/${copfilter_swroot}/etc/clamd_counter") or die "Unable to write clamd_counter file";
                        flock(FILE, 2);
                        print FILE "$clamd_updateperiod\n";
                        close FILE;
                }
           }

           if ( ! -e "${copfilter_swroot}/etc/fprot_counter") {
                if ($copfiltersettings{'FPROT_UPDATE_METHOD'} eq 'periodically')
                {
                        open(FILE, ">/${copfilter_swroot}/etc/fprot_counter") or die "Unable to write fprot_counter file";
                        flock(FILE, 2);
                        print FILE "$fprot_updateperiod\n";
                        close FILE;
                }
           }



           if ( ! -e "${copfilter_swroot}/etc/avg_counter") {
                if ($copfiltersettings{'AVG_UPDATE_METHOD'} eq 'periodically')
                {
                        open(FILE, ">/${copfilter_swroot}/etc/avg_counter") or die "Unable to write avg_counter file";
                        flock(FILE, 2);
                        print FILE "$avg_updateperiod\n";
                        close FILE;
                }
           }


           if ( ! -e "${copfilter_swroot}/etc/avast_counter") {
                if ($copfiltersettings{'AVAST_UPDATE_METHOD'} eq 'periodically')
                {
                        open(FILE, ">/${copfilter_swroot}/etc/avast_counter") or die "Unable to write avast_counter file";
                        flock(FILE, 2);
                        print FILE "$avast_updateperiod\n";
                        close FILE;
                }
           }







# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
        if ( ! ($copfiltersettings{'SKIP_RESTART'} eq 'on' )) {
            &copfilter_start_log(); 
            print "<br /><b>$Lang::tr{'copfilter restart0'} clamd..</b> <br />";
            system('/usr/local/bin/copfilter_restartclamd');


           if ( -e "${copfilter_swroot}/opt/avg/default/bin/avgscan") {
#            if ( -e "/opt/avg/av/bin/avgscan") {
                print "<br /><b>$Lang::tr{'copfilter restart0'} avgscan..</b> <br />";
                system('/usr/local/bin/copfilter_restartavgscan');
            }




            if ( -e "${copfilter_swroot}/opt/f-prot/default/fpscand") {
                print "<br /><b>$Lang::tr{'copfilter restart0'} fpscand..</b> <br />";
                system('/usr/local/bin/copfilter_restartf-protd');
            }

            print "<br /><b>$Lang::tr{'copfilter restart0'} havp..</b> <br />";
            system('/usr/local/bin/copfilter_restarthavp');

            print "<br /><b>$Lang::tr{'copfilter restart0'} c-icap..</b> <br />";
            system('/usr/local/bin/copfilter_restartc-icap');

            print "<br /><b>$Lang::tr{'copfilter restart0'} privoxy..</b> <br />";
            system('/usr/local/bin/copfilter_restartprivoxy');

            print "<br /><br /><b>$Lang::tr{'copfilter restart0'} frox..</b> <br />";
            system('/usr/local/bin/copfilter_restartfrox');

            print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
            system('/usr/local/bin/copfilter_restartmonit');
            &copfilter_stop_log(); 
        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }


}





################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "&nbsp;</class>\n";
    &Header::closebox();
}




################################################################################
##  Website - AntiVirus
################################################################################
my $CLAMDCOL = '';
if ($copfiltersettings{'CLAMD_ENABLE'} !~ /^off$/) {
$CLAMDCOL='#009C28'; }else {
$CLAMDCOL='#C1C1C1'; }

my $BYTECOL = '';
if ($copfiltersettings{'CLAMD_BYTECODE_ENABLE'} !~ /^off$/) {
$BYTECOL='#009C28'; }else {
$BYTECOL='#C1C1C1'; }

my $SAFEBCOL = '';
if ($copfiltersettings{'CLAMD_SAFEBROWSE_ENABLE'} !~ /^off$/) {
$SAFEBCOL='#009C28'; }else {
$SAFEBCOL='#C1C1C1'; }

my $EZIPSCOL = '';
if ($copfiltersettings{'CLAMD_VIRUS_EZIPS'} !~ /^off$/) {
$EZIPSCOL='#009C28'; }else {
$EZIPSCOL='#C1C1C1'; }

my $PHISHCOL = '';
if ($copfiltersettings{'CLAMD_PHISHING_SIGS'} !~ /^off$/) {
$PHISHCOL='#009C28'; }else {
$PHISHCOL='#C1C1C1'; }

my $GUICOL = '';
if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} !~ /^off$/) {
$GUICOL='#009C28'; }else {
$GUICOL='#C1C1C1'; }

my $FPROTCOL = '';
if ($copfiltersettings{'FPROT_ENABLE'} !~ /^off$/) {
$FPROTCOL='#009C28'; }else {
$FPROTCOL='#C1C1C1'; }

my $AVGCOL = '';
if ($copfiltersettings{'AVG_ENABLE'} !~ /^off$/) {
$AVGCOL='#009C28'; }else {
$AVGCOL='#C1C1C1'; }

my $AVASTCOL = '';
if ($copfiltersettings{'AVAST_ENABLE'} !~ /^off$/) {
$AVASTCOL='#009C28'; }else {
$AVASTCOL='#C1C1C1'; }




my $output = `/etc/rc.d/init.d/copfilter_clamd pid weboutput`;
my $status = "";
if ( $output =~ /OFF/ ) { $status="<td nowrap height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF' size='2.7em'><b> STOPPED <\/b><\/font></td>"; }
if ( $output =~ /NOT ACTIVATED/ ) { $status="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font></td>";; }
if ( $output =~ /ON/ ) { $status="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font></td>";; }

if ( $UPDATE eq 1 ){
$updatestatus="<font color='#C01327'><b> $Lang::tr{'copfilter clamd thrdp_info11'} VERSION $NEW_VER $Lang::tr{'copfilter clamd thrdp_info12'} <\/b><\/font>"; }
else { $updatestatus='';}

print "<a name='antivirus'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter antivirus'} (ClamAV, AVG, AVAST, F-Prot):");
print "<form method='post' action='/cgi-bin/copfilter_antivirus.cgi' enctype='multipart/form-data'>";

##### ClamAV

print <<END
<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='75%'></td>
</tr>
<tr>
    <td nowrap><font size='2.7em'><b>ClamAV Status:</b></td>
	$status
END
;

if ( $nbr_virus gt 0){
	print "<td nowrap align='right'> <b><font size='2.7em' color='#810000'>$Lang::tr{'copfilter virus_in_quarantine1'}$nbr_virus$Lang::tr{'copfilter virus_in_quarantine2'}</font></b> </td>";}

print <<END
</tr>
</table>

<table width='100%' border='0' cellpadding='3' cellspacing='3'>
<tr>
	<td nowrap width='6%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='12%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='15%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='12%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='3%'></td>
	<td nowrap width='10%'></td>
	<td nowrap width='30%'></td>
</tr>

<tr>
	<td nowrap><b><u>ClamAV:</u> * </b></td>
       	<td nowrap> <select name='CLAMD_ENABLE' style="border:2px solid $CLAMDCOL;">
             <option value='on' $selected{'CLAMD_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'CLAMD_ENABLE'}{'off'}>off</option> </select></td>
END
;
if ( $THRDP eq 1){
print <<END
		<td nowrap align='right'>$Lang::tr{'copfilter clamd bytecode'} *** </td>
       	<td nowrap><select name='CLAMD_BYTECODE_ENABLE' style="border:2px solid $BYTECOL;">
             <option value='on' $selected{'CLAMD_BYTECODE_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'CLAMD_BYTECODE_ENABLE'}{'off'}>off</option> </select></td>

		<td nowrap align='right'>$Lang::tr{'copfilter clamd safebrowse'} *** </td>
       	<td nowrap><select name='CLAMD_SAFEBROWSE_ENABLE' style="border:2px solid $SAFEBCOL;">
             <option value='on' $selected{'CLAMD_SAFEBROWSE_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'CLAMD_SAFEBROWSE_ENABLE'}{'off'}>off</option> </select></td>
END
;
}else{
print <<END
	<td nowrap></td>
	<td nowrap></td>
	<td nowrap></td>
	<td nowrap></td>
END
;}
print <<END
		<td nowrap align='right'>$Lang::tr{'copfilter clamd virus ezips'}</td>
		<td nowrap><select name='CLAMD_VIRUS_EZIPS' style="border:2px solid $EZIPSCOL;">
             <option value='on' $selected{'CLAMD_VIRUS_EZIPS'}{'on'}>on</option>
             <option value='off' $selected{'CLAMD_VIRUS_EZIPS'}{'off'}>off</option> </select></td>

	<td nowrap></td>
        <td nowrap> $Lang::tr{'copfilter clamstats'} </td>
        <td nowrap> $Lang::tr{'copfilter clamstats2'} </td</tr>
</table>
<table width='100%' border='0' cellpadding='2'>
<tr>
        <td nowrap width='28%'></td>
        <td nowrap width='5%'></td>
        <td nowrap width='23%'></td>
        <td nowrap width='24%'></td>
        <td nowrap width='20%'></td>
</tr>
<tr>
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter clam_sig'}:</b></td>
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter automatic update'}:</b></td>
        <td nowrap colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>
<tr>
        <td nowrap colspan='2' valign='top'>
END
;

########### ClamAV START ######################
# ClamAV Version und Version der aktuellen Signaturen
$version = `/var/log/copfilter/default/opt/clamav/default/sbin/clamd -V | cut -d "/" -f 1`;
$main = `cat /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION |/bin/grep -E "^main" | cut -d ":" -f 2 | cut -d "," -f 1 | cut -d " " -f 2`;
$daily = `cat /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION |/bin/grep -E "^daily" | cut -d ":" -f 2 | cut -d "," -f 1 | cut -d " " -f 2`;
$safebrowse = `cat /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION |/bin/grep -E "^safebrowsing" | cut -d ":" -f 2 | cut -d "," -f 1 | cut -d " " -f 2`;
$bytecode = `cat /var/log/copfilter/default/opt/clamav/var/log/CURRENTVERSION |/bin/grep -E "^bytecode" | cut -d ":" -f 2 | cut -d "," -f 1 | cut -d " " -f 2`;

chop($version);
chop($main);
chop($daily);

$output = "$version|main $main|daily $daily";
if ( ! $bytecode eq ''){
	chop($bytecode);
	$output = "$output|bytecode $bytecode";
}
if ( ! $safebrowse eq ''){
	chop($safebrowse);
	$output = "$output|safebrowsing $safebrowse";
}


print "$output\n"; 
print "<br>";
######### Clamav Datenbanken ###########
print "<br><b>$Lang::tr{'clamav_database'}:</b>";
# Version der main-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/main.cld" ){ 
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep main.cld | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
} 
elsif ( -e "/var/log/copfilter/default/opt/clamav/virdb/main.cvd" ){ 
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep main.cvd | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
} 

#Version der daily-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/daily.cld" ){ 
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep daily.cld | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
} 
elsif ( -e "/var/log/copfilter/default/opt/clamav/virdb/daily.cvd" ){ 
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep daily.cvd | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
}

#Version der bytecode-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/bytecode.cld" ){ 
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep bytecode.cld | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
} 
elsif ( -e "/var/log/copfilter/default/opt/clamav/virdb/bytecode.cvd" ){ 
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep bytecode.cvd | sed 's/  */ /g' | cut -d " " -f 6-`;
$output = &Header::cleanhtml($output,"y"); 
print "<br>$output\n"; 
}

######### Google Datenbank ###########
#Version der Safebrowsing-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/safebrowsing.cld" ){ 
$safebrowse = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep safebrowsing.cld | sed 's/  */ /g' | cut -d " " -f 6-`;

$safebrowse = &Header::cleanhtml($safebrowse,"y"); 
print "<br>";
print "<br><b>$Lang::tr{'google_database'}:</b>";
print "<br>$safebrowse\n"; 
} 
elsif ( -e "/var/log/copfilter/default/opt/clamav/virdb/safebrowsing.cvd" ){ 
$safebrowse = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep safebrowsing.cvd | sed 's/  */ /g' | cut -d " " -f 6-`;
$safebrowse = &Header::cleanhtml($safebrowse,"y"); 
print "<br>";
print "<br><b>$Lang::tr{'google_database'}:</b>";
print "<br>$safebrowse\n"; 
}

######### Sanesecurity Datenbanken ###########
#Version der Phishing-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/phish.ndb" ){ 
$phish = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep phish.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$phish = &Header::cleanhtml($phish,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Scam-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/scam.ndb" ){ 
$scam = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep scam.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
 
$scam = &Header::cleanhtml($scam,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  

#Version der Scamnailer-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/scamnailer.ndb" ){ 
$scamnailer = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep scamnailer.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$scamnailer = &Header::cleanhtml($scamnailer,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  

#Version der Filetype-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/sanesecurity.ftm" ){ 
$filetype = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep sanesecurity.ftm | sed 's/  */ /g' | cut -d " " -f 6-`;
$filetype = &Header::cleanhtml($filetype,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Spam-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spam.ldb" ){ 
$spam = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep spam.ldb | sed 's/  */ /g' | cut -d " " -f 6-`;
$spam = &Header::cleanhtml($spam,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der SpamImage-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spamimg.hdb" ){ 
$spamimg = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep spamimg.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
#$spamimg = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep spamimg.hdb |cut -c 36-61`; 
$spamimg = &Header::cleanhtml($spamimg,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  


#Version der Lott-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/lott.ndb" ){ 
$lott = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep lott.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$lott = &Header::cleanhtml($lott,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Spear-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spear.ndb" ){ 
$spear = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep spear.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$spear = &Header::cleanhtml($spear,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  

#Version der SpearLink-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spearl.ndb" ){ 
$spearl = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep spearl.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$spearl = &Header::cleanhtml($spearl,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  


#Version der Junk-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/junk.ndb" ){ 
$junk = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep junk.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$junk = &Header::cleanhtml($junk,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 


#Version der Junk-URLBLA-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/jurlbla.ndb" ){ 
$jurlbla = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep jurlbla.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$jurlbla = &Header::cleanhtml($jurlbla,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Junk-URLBL-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/jurlbl.ndb" ){ 
$jurlbl = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep jurlbl.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$jurlbl = &Header::cleanhtml($jurlbl,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Rogue-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/rogue.hdb" ){ 
$rogue = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep rogue.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$rogue = &Header::cleanhtml($rogue,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  

#Version der Spamattach-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spamattach.hdb" ){ 
$spamattach = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep spamattach.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$spamattach = &Header::cleanhtml($spamattach,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
}  

#Version der Blurl-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/blurl.ndb" ){ 
$blurl = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep blurl.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$blurl = &Header::cleanhtml($blurl,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Foxhole-All-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/foxhole_all.cdb" ){ 
$foxall = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep foxhole_all.cdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$foxall = &Header::cleanhtml($foxall,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Foxhole-Generic-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/foxhole_generic.cdb" ){ 
$foxgen = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep foxhole_generic.cdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$foxgen = &Header::cleanhtml($foxgen,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

#Version der Foxhole-Filename-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/foxhole_filename.cdb" ){ 
$foxfile = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep foxhole_filename.cdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$foxfile = &Header::cleanhtml($foxfile,"y"); 
$sanesec = "$Lang::tr{'sanesec_database'}:";
} 

######### BOFHLAND Datenbanken ###########
#Version der Crash-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/bofhland_cracked_URL.ndb" ){ 
$bofcrack = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep bofhland_cracked_URL.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$bofcrack = &Header::cleanhtml($bofcrack,"y");
$bofhland = "$Lang::tr{'bofhland_database'}:";
} 

#Version der Mal-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/bofhland_malware_URL.ndb" ){ 
$bofmal = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep bofhland_malware_URL.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$bofmal = &Header::cleanhtml($bofmal,"y"); 
$bofhland = "$Lang::tr{'bofhland_database'}:";
} 

#Version der Phish-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/bofhland_phishing_URL.ndb" ){ 
$bofphish = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep bofhland_phishing_URL.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$bofphish = &Header::cleanhtml($bofphish,"y"); 
$bofhland = "$Lang::tr{'bofhland_database'}:";
}  

#Version der MalAttach-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/bofhland_malware_attach.hdb" ){ 
$bofatt = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep bofhland_malware_attach.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$bofatt = &Header::cleanhtml($bofatt,"y"); 
$bofhland = "$Lang::tr{'bofhland_database'}:";
}  

######## OITC Datenbanken #################

#Version der winnow_malware-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/winnow_malware.hdb" ){ 
$wmal = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep winnow_malware.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wmal = &Header::cleanhtml($wmal,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

#Version der winnow_extended_malware-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/winnow_extended_malware.hdb" ){ 
$wext = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep winnow_extended_malware.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wext = &Header::cleanhtml($wext,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

#Version der winnow_phish-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/winnow_phish_complete.ndb" ){ 
$wphsh = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep winnow_phish_complete.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wphsh = &Header::cleanhtml($wphsh,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
}  

#Version der winnow_spam-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/winnow_spam_complete.ndb" ){ 
$wspam = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep winnow_spam_complete.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wspam = &Header::cleanhtml($wspam,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

#Version der winnow_complex-pattern-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/winnow.complex.patterns.ldb" ){ 
$wpatt = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep winnow.complex.patterns.ldb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wpatt = &Header::cleanhtml($wpatt,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

#Version der winnow_attachment-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/winnow.attachments.hdb" ){ 
$wattach = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep winnow.attachments.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wattach = &Header::cleanhtml($wattach,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

#Version der winnow_bad_cw-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/winnow_bad_cw.hdb" ){ 
$wbad = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep winnow_bad_cw.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$wbad = &Header::cleanhtml($wbad,"y"); 
$oitc = "$Lang::tr{'oitc_database'}:";
} 

######### Porcupine Datenbanken ###########
#Version der Porcupine-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/porcupine.ndb" ){ 
$porcupine = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep porcupine.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$porcupine = &Header::cleanhtml($porcupine,"y");
$porcupdb = "$Lang::tr{'porcupine_database'}:";
} 

#Version der Phishtank-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/phishtank.ndb" ){ 
$phishtank = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep phishtank.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$phishtank = &Header::cleanhtml($phishtank,"y"); 
$porcupdb = "$Lang::tr{'porcupine_database'}:"; 
} 

######## Julian Field Datenbanken #################
#Version der Scamnailer-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/scamnailer.ndb" ){ 
$scamnailer = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep scamnailer.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$scamnailer = &Header::cleanhtml($scamnailer,"y"); 
$jfld = "$Lang::tr{'jfld_database'}:";
}  

######## CRDF Datenbanken #################
#Version der CRDFAM-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/crdfam.clamav.hdb" ){ 
$crdfam = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep crdfam.clamav.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$crdfam = &Header::cleanhtml($crdfam,"y"); 
$crdf = "$Lang::tr{'crdf_database'}:";
}  

######### Securiteinfo Datenbanken ###########
#Version der batch-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/securiteinfobat.hdb" ){ 
$sibat = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep securiteinfobat.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sibat = &Header::cleanhtml($sibat,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der Secureteinfo-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/securiteinfo.hdb" ){ 
$sisecinf = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep securiteinfo.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sisecinf = &Header::cleanhtml($sisecinf,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der Marketing-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/spam_marketing.ndb" ){ 
$simark = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep spam_marketing.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
$simark = &Header::cleanhtml($simark,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der Honeynet-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/honeynet.hdb" ){ 
$sihon = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep honeynet.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sihon = &Header::cleanhtml($sihon,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der DOS-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/securiteinfodos.hdb" ){ 
$sidos = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep securiteinfodos.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sidos = &Header::cleanhtml($sidos,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der ELF-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/securiteinfoelf.hdb" ){ 
$sielf = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep securiteinfoelf.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sielf = &Header::cleanhtml($sielf,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der HTML-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/securiteinfohtml.hdb" ){ 
$sihtm = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep securiteinfohtml.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sihtm = &Header::cleanhtml($sihtm,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der Office-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/securiteinfooffice.hdb" ){ 
$sioff = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep securiteinfooffice.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sioff = &Header::cleanhtml($sioff,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der PDF-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/securiteinfopdf.hdb" ){ 
$sipdf = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep securiteinfopdf.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sipdf = &Header::cleanhtml($sipdf,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

#Version der BASH-Datenbank
if ( -e "/var/log/copfilter/default/opt/clamav/virdb/securiteinfosh.hdb" ){ 
$sish = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep securiteinfosh.hdb | sed 's/  */ /g' | cut -d " " -f 6-`;
$sish = &Header::cleanhtml($sish,"y"); 
$sidb = "$Lang::tr{'securiteinfo_database'}:"; 
} 

######### MalwarePatrol Datenbank ###########
#Version der Malware-Datenbank
#if ( -e "/var/log/copfilter/default/opt/clamav/virdb/mbl.ndb" ){ 
#$mbl = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/clamav/virdb/ |grep mbl.ndb | sed 's/  */ /g' | cut -d " " -f 6-`;
#$mbl = &Header::cleanhtml($mbl,"y");
#$mbldb = "$Lang::tr{'malware_database'}:"; 
#}

if ( ! $sidb eq '' ){
print "<br>";
print "<br><a href='http://www.securiteinfo.com/services/clamav_unofficial_malwares_signatures.shtml' target='_blank'><b>$sidb</b></a>";
	if ( ! $sihon eq ''){
		print "<br>$sihon";
	}
	if ( ! $sisecinf eq ''){
		print "<br>$sisecinf";
	}
	if ( ! $sibat eq ''){
		print "<br>$sibat";
	}
	if ( ! $sidos eq ''){
		print "<br>$sidos";
	}
	if ( ! $sielf eq ''){
		print "<br>$sielf";
	}
	if ( ! $sihtm eq ''){
		print "<br>$sihtm";
	}
	if ( ! $sioff eq ''){
		print "<br>$sioff";
	}
	if ( ! $sipdf eq ''){
		print "<br>$sipdf";
	}
	if ( ! $sish eq ''){
		print "<br>$sish";
	}
	if ( ! $simark eq ''){
		print "<br>$simark";
	}
}

######### zum naechsten FreshClam Update ################
if ( -e "${copfilter_swroot}/etc/clamd_counter" && $copfiltersettings{'CLAMD_UPDATE_METHOD'} eq 'periodically' ){
my $nextupd = '';
my $nexttime = 0;
my $nextday = 0;
my $nexthour = 0;
my $nextminute = 0;
$nexttime = `cat /var/log/copfilter/default/etc/clamd_counter` + 5;

$nextday = ($nexttime - $nexttime % 1440) / 1440;
$nexthour = ($nexttime % 1440 - $nexttime % 1440 % 60) / 60;
$nextminute = $nexttime - $nextday * 1440 - $nexthour * 60;

if ($nextday > 0){
if ($nexthour < 10 ){ $nexthour = "0$nexthour"; }
if ($nextminute < 10){ $nextminute = "0$nextminute"; }
$nextupd = "<br><br><b>$nextday:$nexthour:$nextminute $Lang::tr{'copfilter days'} $Lang::tr{'clamav_update'} </b>";
}elsif($nexthour > 0){
if ($nextminute < 10){ $nextminute = "0$nextminute"; }
$nextupd = "<br><br><b>$nexthour:$nextminute $Lang::tr{'copfilter hours'} $Lang::tr{'clamav_update'} </b>";
}else{
$nextupd = "<br><br><b>$nextminute $Lang::tr{'copfilter minutes'} $Lang::tr{'clamav_update'} </b>";}
print "$nextupd";}




########### ClamAV ENDE ######################

########### ClamAV ENDE ######################
print <<END
</td>
        <td nowrap valign='top'>
        <input type='radio' name='CLAMD_UPDATE_METHOD' value='periodically' $selected{'CLAMD_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='CLAMD_UPDATE_METHOD' value='manually'     $selected{'CLAMD_UPDATE_METHOD'}{'manually'}     />$Lang::tr{'copfilter disabled'}
	<br>
END
;

	if ( ! $sanesec eq ''){
		print "<br><a href='http://sanesecurity.com/usage/signatures/' target='_blank'><b>$sanesec</b></a>";
	}
	if ( ! $blurl eq '' ){
		print "<br>$blurl";
	}
	if ( ! $foxall eq '' ){
		print "<br>$foxall";
	}
	if ( ! $foxfile eq '' ){
		print "<br>$foxfile";
	}
	if ( ! $foxgen eq '' ){
		print "<br>$foxgen";
	}
	if ( ! $jurlbl eq '' ){
		print "<br>$jurlbl";
	}
	if ( ! $jurlbla eq '' ){
		print "<br>$jurlbla";
	}
	if ( ! $junk eq '' ){
		print "<br>$junk";
	}
	if ( ! $lott eq '' ){
		print "<br>$lott";
	}
	if ( ! $phish eq '' ){
		print "<br>$phish";
	}
	if ( ! $rogue eq '' ){
		print "<br>$rogue";
	}
	if ( ! $filetype eq '' ){
		print "<br>$filetype";
	}
	if ( ! $scam eq '' ){
		print "<br>$scam";
	}
	if ( ! $spam eq '' ){
		print "<br>$spam";
	}
	if ( ! $spamattach eq '' ){
		print "<br>$spamattach";
	}
	if ( ! $spamimg eq '' ){
		print "<br>$spamimg";
	}
	if ( ! $spear eq '' ){
		print "<br>$spear";
	}
	if ( ! $spearl eq '' ){
		print "<br>$spearl";
	}

print <<END        
	<td nowrap valign='top'><input type='text' name='CLAMD_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'CLAMD_UPDATE_VALUE'}' />
        <select name='CLAMD_UPDATE_PERIOD'>
                <option value='minutely' $selected{'CLAMD_UPDATE_PERIOD'}{'minutely'}>$Lang::tr{'copfilter minutes'}</option>
                <option value='hourly' $selected{'CLAMD_UPDATE_PERIOD'}{'hourly'}>$Lang::tr{'copfilter hours'}</option>
                <option value='daily' $selected{'CLAMD_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'CLAMD_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'CLAMD_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>
        </select>
END
;

	print "<br>";
	if ( ! $oitc eq ''){
		print "<br>";
		print "<br><a href='http://www.oitc.com/winnow/clamsigs/index.html' target='_blank'><b>$oitc</b></a>";
	}
	if ( ! $wattach eq '' ){
		print "<br>$wattach";
	}
	if ( ! $wbad eq '' ){
		print "<br>$wbad";
	}
	if ( ! $wpatt eq '' ){
		print "<br>$wpatt";
	}
	if ( ! $wext eq '' ){
		print "<br>$wext";
	}
	if ( ! $wmal eq '' ){
		print "<br>$wmal";
	}
	if ( ! $wphsh eq '' ){
		print "<br>$wphsh";
	}
	if ( ! $wspam eq '' ){
		print "<br>$wspam";
	}



########## removed since 2.1.92beta2
#	if ( ! $lwdb eq ''){
#	print "<br>";
#	print "<br><a href='http://opensource.doppelstern.com/' target='_blank'><b>$lwdb</b></a>";
#		if ( ! $lwim eq ''){
#			print "<br>$lwim";
#		}
#		if ( ! $lwsp eq ''){
#			print "<br>$lwsp";
#		}
#	}
	if ( ! $crdf eq ''){
		print "<br>";
		print "<br><a href='http://threatcenter.crdf.fr' target='_blank'><b>$crdf</b></a>";
		if ( ! $crdfam eq ''){
			print "<br>$crdfam";
		} 
	}

print <<END        
        <td nowrap valign='top' align='left'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter clamd update now'}' /> 
END
;


if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_clamav.done" ){
   print "<font color='#339933'>DONE</font>";
   system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_clamav.done");
}

	print "<br>";
	if ( ! $jfld eq ''){
		print "<br>";
		print "<br><a href='http://www.scamnailer.info' target='_blank'><b>$jfld</b></a>";
	}
	if ( ! $scamnailer eq '' ){
		print "<br>$scamnailer";
	}
	if ( ! $porcupdb eq ''){
	print "<br>";
	print "<br><a href='http://sanesecurity.com/usage/signatures/' target='_blank'><b>$porcupdb</b></a>";
		if ( ! $phishtank eq ''){
			print "<br>$phishtank";
		}
		if ( ! $porcupine eq ''){
			print "<br>$porcupine";
		}
	}
	if ( ! $mbldb eq ''){
	    $mbldb='';
	}
#	print "<br>";
#	print "<br><a href='http://www.malware.com.br/lists.shtml' target='_blank'><b>$mbldb</b></a>";
#		if ( ! $mbl eq ''){
#			print "<br>$mbl";
#		} 
#	}
	if ( ! $bofhland eq ''){
	print "<br>";
	print "<br><a href='http://clamav.bofhland.org' target='_blank'><b>$bofhland</b></a>";
		if ( ! $bofcrack eq ''){
			print "<br>$bofcrack";
		} 
		if ( ! $bofatt eq ''){
			print "<br>$bofatt";
		} 
		if ( ! $bofmal eq ''){
			print "<br>$bofmal";
		} 
		if ( ! $bofphish eq ''){
			print "<br>$bofphish";
		} 
	}



print <<END
</td></td>
</tr>
</table>
<table width='100%' cellpadding='5' border='0'>
<tr>
<td nowrap width='25%'></td>
<td nowrap width='15%'></td>
<td nowrap width='20%'></td>
<td nowrap width='15%'></td>
<td nowrap width='25'></td>
</tr>
END
;

if ( $THRDP eq 1 ){
print "<tr>";
print	"<td nowrap>	$Lang::tr{'copfilter clamd phishing_sigs'}";

	if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on' ) {
	print " ******";
	}
print <<END
	</td>
        <td nowrap> <select name='CLAMD_PHISHING_SIGS' style="border:2px solid $PHISHCOL;">
             <option value='off' $selected{'CLAMD_PHISHING_SIGS'}{'off'}>off</option>
             <option value='on' $selected{'CLAMD_PHISHING_SIGS'}{'on'}>on</option> </select></td>
END
;


if ($copfiltersettings{'CLAMD_PHISHING_SIGS'} eq 'on' ) {
print <<END
	<td nowrap>$Lang::tr{'copfilter clamd thrdp_gui'}</td>
	<td nowrap><select name='THRDP_SHOW_GUI_ENABLE' style="border:2px solid $GUICOL;">
	<option value='off' $selected{'THRDP_SHOW_GUI_ENABLE'}{'off'}>off</option>
	<option value='on' $selected{'THRDP_SHOW_GUI_ENABLE'}{'on'}>on</option> </select></td>
END
;
if ( $CUR_VER ne '' ) {

print <<END
	<td nowrap colspan = '2' nowrap><b><font size='0.5em'>$Lang::tr{'copfilter clamd thrdp_info9'}$CUR_VER<br> $updatestatus </font></b></td></td></td>
END
;
}
else {
print <<END
	</td></td>
END
;
}
}
}

if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on' ) {
print <<END
</table>
<table width='100%' border='0' cellpadding='2' style="border:outset #6B8E23 7px; margin-top:5px; padding-top:0px; padding-bottom:5px; padding-right:5px; padding-left:5px;">
<tr>
        <td nowrap width='20%'></td>
        <td nowrap width='20%'></td>
        <td nowrap width='20%'></td>
        <td nowrap width='20%'></td>
        <td nowrap width='20%'></td>
</tr>
        <td nowrap>

	<a href='http://sanesecurity.com/usage/signatures/' target='_blank'><b>$Lang::tr{'copfilter clamd thrdp_info5'}</b> ****</a>

END
;
	$actthrdp = 'THRDP_MAIL_NOTIF_ENABLE';
	if ($copfiltersettings{$actthrdp} eq 'off' ) {
		$style = 'style="border-color:#FFFFFF; border-style:none; border-width:0px;"'; }
	elsif ($copfiltersettings{$actthrdp} eq 'on' ) {
		$style = 'style="border-color:#FFD700; border-style:outset; border-width:3px;"';	}
	elsif ($copfiltersettings{$actthrdp} eq 'error' ) {
		$style = 'style="border-color:#FFD700; border-style:dotted; border-width:3px;"';	}
print <<END
	<td nowrap $style><select name=$actthrdp>
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='error' $selected{$actthrdp}{'error'}>error</option> </select>
	$Lang::tr{'copfilter clamd thrdp_notif'}</td>
END
;	
}

if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on' ) {
	if ( system ('/bin/grep "THRDP_ADD_HEADER_ENABLE" /var/log/copfilter/default/etc2/copfilter_functions &>/dev/null 2>&1') eq 0){
	$actthrdp = 'THRDP_ADD_HEADER_ENABLE';
	if ($copfiltersettings{$actthrdp} eq 'off' ) {
		$style = 'style="border-color:#FFFFFF; border-style:none; border-width:0px;"'; }
	elsif ( $copfiltersettings{$actthrdp} eq 'on') {
		if ( $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} eq 'on' || $copfiltersettings{'POP3_MAIL_ADD_HEADER'} eq 'on' ) { 
		$style = 'style="border-color:#FFD700; border-style:outset; border-width:3px;"';	}
		else  { $style = 'style="border-color:#FFFFFF; border-style:none; border-width:0px;"'; }}

print <<END
	<td nowrap $style><select name=$actthrdp>
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option> </select>
	$Lang::tr{'copfilter clamd add_header'}</td>
END
;	

	$actthrdp = 'THRDP_ADD_FOOTER_ENABLE';
	if ($copfiltersettings{$actthrdp} eq 'off' ) {
		$style = 'style="border-color:#FFFFFF; border-style:none; border-width:0px;"'; }
	elsif ( $copfiltersettings{$actthrdp} eq 'on') {
		if ( $copfiltersettings{'SMTP_MAIL_ADD_BODY'} eq 'on' || $copfiltersettings{'POP3_MAIL_ADD_BODY'} eq 'on' ) { 
		$style = 'style="border-color:#FFD700; border-style:outset; border-width:3px;"';	}
		else  { $style = 'style="border-color:#FFFFFF; border-style:none; border-width:0px;"'; }}
print <<END
	<td nowrap colspan = '2' $style><select name=$actthrdp>
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option> </select>
	$Lang::tr{'copfilter clamd add_footer'}</td>

END
;
}
}


if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on' ) {
print <<END
	<tr><tr><tr><tr><td><a href='http://sanesecurity.com/usage/signatures/' target='_blank'><b>Sanesecurity</b></a></td>
	<td><a href='http://www.oitc.com/winnow/clamsigs/index.html' target='_blank'><b>OITC</b> *****</a></td>
	<td><a href='http://threatcenter.crdf.fr' target='_blank'><b>CRDF</b> *****</a></td>
	<td><a href='http://www.securiteinfo.com/services/clamav_unofficial_malwares_signatures.shtml' target='_blank'><b>SecuriteInfo</b></a></td>
	<td><a href='http://sanesecurity.com/usage/signatures/' target='_blank'><b>Porcupine</b></a></td>
	<tr><tr><tr><tr>
	</tr></tr></tr></tr></tr></tr></tr></tr>
END
;
    $actthrdp = 'THRDP_SPAM_ENABLE';
    my $OPTCOL='';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;" >
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        spam.ldb</td>
END
;
    $actthrdp = 'THRDP_WSPAM_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td> <select name=$actthrdp style="border:2px solid $OPTCOL;" >
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        winnow_spam_complete.ndb</td>
END
;
    $actthrdp = 'THRDP_CRDFAM_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;" >
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        crdfam.clamav.hdb</td>
END
;
    $actthrdp = 'THRDP_SECURITEINFO_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp  style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        securiteinfo.hdb</td>
END
;
    $actthrdp = 'THRDP_PORCUPINE_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp  style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        porcupine.ndb</td>
        <tr>
END
;
    $actthrdp = 'THRDP_SPAMIMG_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp  style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        spamimg.hdb</td>
END
;
    $actthrdp = 'THRDP_WPHSH_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp  style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        winnow_phish_complete.ndb</td>
        <td><a href='http://www.scamnailer.info' target='_blank'><b>Julian Field</b> *****</a></td>
END
;
    $actthrdp = 'THRDP_HONEYNET_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp  style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        honeynet.hdb</td>
END
;
    $actthrdp = 'THRDP_PTANK_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        phishtank.ndb</td>
        <tr>
END
;
    $actthrdp = 'THRDP_LOTT_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        lott.ndb</td>
END
;
    $actthrdp = 'THRDP_WMAL_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        winnow_malware.hdb</td>
END
;
    $actthrdp = 'THRDP_SCAMNAILER_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        scamnailer.ndb</td>
END
;
    $actthrdp = 'THRDP_SECINFOBAT_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        securiteinfobat.hdb</td>
        <tr>
END
;
    $actthrdp = 'THRDP_SPEAR_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        spear.ndb</td>
END
;
    $actthrdp = 'THRDP_WPATT_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        winnow.complex.patterns.ldb</td>
        <td><a href='http://clamav.bofhland.org' target='_blank'><b>BOFHLAND</b> *****</a></td>
END
;
    $actthrdp = 'THRDP_SECINFODOS_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        securiteinfodos.hdb</td></td>
END
;
#    $actthrdp = 'THRDP_MBL_ENABLE';
#    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }

#        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
#             <option value='off' $selected{$actthrdp}{'off'}>off</option>
#             <option value='on' $selected{$actthrdp}{'on'}>on</option>
#             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
#        mbl.ndb</td>
print <<END
        <tr>
END
;
    $actthrdp = 'THRDP_SPEARL_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
    <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        spearl.ndb</td>
END
;
    $actthrdp = 'THRDP_WATTACH_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        winnow.attachments.hdb</td>
END
;
    $actthrdp = 'THRDP_BOFCRACK_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        bofhland_cracked_URL.ndb</td>
END
;
    $actthrdp = 'THRDP_SECINFOELF_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        securiteinfoelf.hdb</td></td>
        <tr>
END
;
    $actthrdp = 'THRDP_JUNK_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        junk.ndb</td>
END
;
    $actthrdp = 'THRDP_WBAD_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        winnow_bad_cw.hdb</td>
END
;
    $actthrdp = 'THRDP_BOFMAL_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        bofhland_malware_URL.ndb</td></td>
END
;
    $actthrdp = 'THRDP_SECINFOHTM_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        securiteinfohtml.hdb</td></td>
        <tr>
END
;
    $actthrdp = 'THRDP_SCAM_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        scam.ndb</td>
END
;
    $actthrdp = 'THRDP_WEXT_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        winnow_extended_malware.hdb</td>
END
;
    $actthrdp = 'THRDP_BOFPHSH_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        bofhland_phishing_URL.ndb</td></td>
END
;
    $actthrdp = 'THRDP_SECINFOOFF_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        securiteinfooffice.hdb</td></td>
        <tr>
END
;
    $actthrdp = 'THRDP_PHISH_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        phish.ndb<td></td></td>
END
;
    $actthrdp = 'THRDP_BOFATT_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        bofhland_malware_attach.hdb</td></td>
END
;
    $actthrdp = 'THRDP_SECINFOPDF_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        securiteinfopdf.hdb</td></td>
        <tr>
END
;
    $actthrdp = 'THRDP_ROGUE_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        rogue.hdb</td><td> </td>
END
;

    $actthrdp = 'THRDP_SECINFOSH_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        securiteinfosh.hdb</td></td>
        <tr>
END
;
    $actthrdp = 'THRDP_JURLBLA_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        jurlbla.ndb</td><td></td>
END
;

    $actthrdp = 'THRDP_SECINFOMARK_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        spam_marketing.ndb</td></td>
        <tr>
END
;
    $actthrdp = 'THRDP_JURLBL_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        jurlbl.ndb</td>
        <tr>
END
;
    $actthrdp = 'THRDP_SPAMATTACH_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        spamattach.hdb</td>
        <tr>
END
;
    $actthrdp = 'THRDP_FOXALL_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        foxhole_all.cdb</td>
        </tr>
        <tr>
END
;
    $actthrdp = 'THRDP_FOXFILE_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        foxhole_filename.cdb</td>
        </tr>
        <tr>
END
;
    $actthrdp = 'THRDP_FOXGEN_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name=$actthrdp style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        foxhole_generic.cdb</td>
        </tr>
        <tr>
END
;
    $actthrdp = 'THRDP_BLURL_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name='THRDP_BLURL_ENABLE' style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        blurl.ndb</td>
END
;

print	<<END
        <td><td><b></font></b></td></td></td>
        <td></b></td></td></td>
        <td></td></td></td>
        <tr>
END
;

    $actthrdp = 'THRDP_FILETYPE_ENABLE';
    if ($copfiltersettings{$actthrdp} eq 'off' ) { $OPTCOL='#C1C1C1'; } else { $OPTCOL='#009C28'; }
print <<END
        <td><select name='THRDP_FILETYPE_ENABLE' style="border:2px solid $OPTCOL;">
             <option value='off' $selected{$actthrdp}{'off'}>off</option>
             <option value='on' $selected{$actthrdp}{'on'}>on</option>
             <option value='havp' $selected{$actthrdp}{'havp'}>havp</option> </select>
        sanesecurity.ftm</td>
        <td><td colspan='1'><a href='http://sanesecurity.com/news/' target='_blank'><b>&nbsp;Sanesecurity News</b></a><br><a href='http://sanesecurity.com/support/status/' target='_blank'><b>&nbsp;Sanesecurity Status Info</b></a></td><td colspan='1'><a href='http://sanesecurity.com/statistics/' target='_blank'><b>&nbsp;Sanesecurity Statistics</b></a><br><a href='http://sanesecurity.com/foxhole-databases/' target='_blank'><b>&nbsp;Sanesecurity Foxhole Infos</b></a></td>
        <td style="colspan:2; padding:0px; padding-right:2px; padding-left:2px;">$Lang::tr{'copfilter clamd thrdp_info6'}</td></td>
</table>
<table width='100%' border='0' cellpadding='2'>
<tr>
        <td width='100%'></td>
</tr>
        <td>
END
;


}



print <<END
    </td>
</tr></tr>

<tr>
        <td nowrap>&nbsp;</td>
</tr>


END
;



if (-e "/home/httpd/cgi-bin/copfilter_clamav_config.cgi") {

print <<END
<table>
<tr>
 
    <td ><form method='post' >
    </form></td>
<td >
    <form method='post' action='/cgi-bin/copfilter_clamav_config.cgi\'>
    <input type='submit' value='$Lang::tr{'copfilter clamav_advanced_config'}' />
    </form></td>
</tr>

	<td nowrap> </td>
<tr>
        <td nowrap>&nbsp;</td>
</tr>

END
;
}


print <<END
<tr>
        <td nowrap>&nbsp;</td>
</tr>
<tr>
        <td nowrap>&nbsp;</td>
</tr>

</table>
END
;












##### AVG

#if ($copfiltersettings{'AVG_INSTALLED'} eq 'yes' ) {
if ( -e "/opt/avg/av/bin/avgd" ){

my $status = "";

my $output = `/etc/rc.d/init.d/copfilter_avgscan pid weboutput`;

if ( $output =~ /OFF/ ) { $status="<td nowrap height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF' size='2.7em'><b> STOPPED <\/b><\/font></td>"; }
if ( $output =~ /NOT ACTIVATED/ ) { $status="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font></td>";; }
if ( $output =~ /ON/ ) { $status="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font></td>";; }



print <<END
<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='75%'></td>
</tr>
<tr>
    <td nowrap><font size='2.7em'><b>AVG Status:</b></td>
    $status
</tr>
</table>

<table width='100%' border='0' cellpadding='2'>
<tr>
        <td nowrap width='6%'></td>
        <td nowrap width='3%'></td>
        <td nowrap width='91%'></td>
</tr>


<tr>
	<td nowrap><b><u>AVG:</u> * </b></td>
       	    <td nowrap> <select name='AVG_ENABLE' style="border:2px solid $AVGCOL;">
             <option value='on' $selected{'AVG_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'AVG_ENABLE'}{'off'}>off</option> </select>
        </td>
</tr>
</table>

<table width='100%' border='0' cellpadding='2'>
<tr>
        <td nowrap width='28%'></td>
        <td nowrap width='5%'></td>
        <td nowrap width='23%'></td>
        <td nowrap width='24%'></td>
        <td nowrap width='20%'></td>
</tr>
<tr>
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter avg_sig'}:</b></td>
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter automatic update'}:</b></td>
        <td nowrap colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>
<tr>
        <td nowrap colspan='2'>
END
;


#$output = `cat 1p /var/log/copfilter/default/opt/avg/CURRENTVERSION |/bin/grep -Ev "^A|^C|^L|^U|^\$"  |/bin/sed -e 's/Version //' -e 'a\<br />'`;
$output = `cat 1p /var/log/copfilter/default/opt/avg/CURRENTVERSION |/bin/sed -n '/version/p'`;
print "$output\n";

$output = $Lang::tr{'copfilter sigdates'};
print "<br>$output";

$output = `cat /var/log/copfilter/default/opt/avg/CURRENTVERSION |/bin/sed -e '/^AVG version/d' -e 'a\<br />'`;
print "$output\n";




######### zum naechsten AVG Update ################
if ( -e "${copfilter_swroot}/etc/avg_counter" && $copfiltersettings{'AVG_UPDATE_METHOD'} eq 'periodically' ){
	my $nextupd = '';
	my $nexttime = 0;
	my $nextday = 0;
	my $nexthour = 0;
	my $nextminute = 0;
	$nexttime = `cat /var/log/copfilter/default/etc/avg_counter` + 5;

	$nextday = ($nexttime - $nexttime % 1440) / 1440;
	$nexthour = ($nexttime % 1440 - $nexttime % 1440 % 60) / 60;
	$nextminute = $nexttime - $nextday * 1440 - $nexthour * 60;

	if ($nextday > 0){
		if ($nexthour < 10 ){ $nexthour = "0$nexthour"; }
		if ($nextminute < 10){ $nextminute = "0$nextminute"; }
	$nextupd = "<br><br><b>$nextday:$nexthour:$nextminute $Lang::tr{'copfilter days'} $Lang::tr{'avg_update'} </b>";
	}elsif($nexthour > 0){
		if ($nextminute < 10){ $nextminute = "0$nextminute"; }
		$nextupd = "<br><br><b>$nexthour:$nextminute $Lang::tr{'copfilter hours'} $Lang::tr{'avg_update'} </b>";
	}else{
		$nextupd = "<br><br><b>$nextminute $Lang::tr{'copfilter minutes'} $Lang::tr{'avg_update'} </b>";}
	print "$nextupd";
}





print <<END
</font>
</td>
        <td nowrap valign='top'><input type='radio' name='AVG_UPDATE_METHOD' value='periodically' $selected{'AVG_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='AVG_UPDATE_METHOD' value='manually' $selected{'AVG_UPDATE_METHOD'}{'manually'} />$Lang::tr{'copfilter disabled'}</td>
        <td nowrap valign='top'><input type='text' name='AVG_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'AVG_UPDATE_VALUE'}' />
        <select name='AVG_UPDATE_PERIOD'>
               <option value='minutely' $selected{'AVG_UPDATE_PERIOD'}{'minutely'}>$Lang::tr{'copfilter minutes'}</option>
               <option value='hourly' $selected{'AVG_UPDATE_PERIOD'}{'hourly'}>$Lang::tr{'copfilter hours'}</option>
                <option value='daily' $selected{'AVG_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'AVG_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'AVG_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>




        </select></td>
        <td nowrap valign='top'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter avg update now'}' />
END
;
if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_avg.done" ){
   print "<font color='#339933'>DONE</font>";
   system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_avg.done");
}

print <<END

	</td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>
END
;

}









##### AVAST

#if ($copfiltersettings{'AVAST_INSTALLED'} eq 'yes' ) {
if ( -e "/usr/bin/avastcmd" ){

my $status = "";

if ($copfiltersettings{'AVAST_ENABLE'} eq 'on' ) {
$status="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> NO DAEMON <\/b><\/font></td>"; }
else {
$status="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font></td>"; }



print <<END
<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='75%'></td>
</tr>
<tr>
    <td nowrap><font size='2.7em'><b>AVAST Status:</b></td>
    $status
</tr>
</table>

<table width='100%' border='0' cellpadding='2'>
<tr>
        <td nowrap width='6%'></td>
        <td nowrap width='3%'></td>
        <td nowrap width='91%'></td>
</tr>


<tr>
	<td nowrap><b><u>AVAST:</u> * </b></td>
       	    <td nowrap> <select name='AVAST_ENABLE' style="border:2px solid $AVASTCOL;">
             <option value='on' $selected{'AVAST_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'AVAST_ENABLE'}{'off'}>off</option> </select>
        </td>
</tr>
</table>

<table width='100%' border='0' cellpadding='2'>
<tr>
        <td nowrap width='28%'></td>
        <td nowrap width='5%'></td>
        <td nowrap width='23%'></td>
        <td nowrap width='24%'></td>
        <td nowrap width='20%'></td>
</tr>
<tr>
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter avast_sig'}:</b></td>
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter automatic update'}:</b></td>
        <td nowrap colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>
<tr>
        <td nowrap colspan='2'>
END
;


$output = `cat 1p /var/log/copfilter/default/opt/avast/CURRENTVERSION |/bin/sed -e '/^AVAST Version/!d'`;
print "$output\n";

$output = $Lang::tr{'copfilter sigdates'};
print "<br>$output";

$output = `cat /var/log/copfilter/default/opt/avast/CURRENTVERSION |/bin/sed -e '/^AVAST Version/d' -e 'a\<br />'`;
print "$output\n";





######### zum naechsten AVAST Update ################
if ( -e "${copfilter_swroot}/etc/avast_counter" && $copfiltersettings{'AVAST_UPDATE_METHOD'} eq 'periodically' ){
	my $nextupd = '';
	my $nexttime = 0;
	my $nextday = 0;
	my $nexthour = 0;
	my $nextminute = 0;
	$nexttime = `cat /var/log/copfilter/default/etc/avast_counter` + 5;

	$nextday = ($nexttime - $nexttime % 1440) / 1440;
	$nexthour = ($nexttime % 1440 - $nexttime % 1440 % 60) / 60;
	$nextminute = $nexttime - $nextday * 1440 - $nexthour * 60;

	if ($nextday > 0){
		if ($nexthour < 10 ){ $nexthour = "0$nexthour"; }
		if ($nextminute < 10){ $nextminute = "0$nextminute"; }
	$nextupd = "<br><br><b>$nextday:$nexthour:$nextminute $Lang::tr{'copfilter days'} $Lang::tr{'avast_update'} </b>";
	}elsif($nexthour > 0){
		if ($nextminute < 10){ $nextminute = "0$nextminute"; }
		$nextupd = "<br><br><b>$nexthour:$nextminute $Lang::tr{'copfilter hours'} $Lang::tr{'avast_update'} </b>";
	}else{
		$nextupd = "<br><br><b>$nextminute $Lang::tr{'copfilter minutes'} $Lang::tr{'avast_update'} </b>";}
	print "$nextupd";
}





print <<END
</font>
</td>
        <td nowrap valign='top'><input type='radio' name='AVAST_UPDATE_METHOD' value='periodically' $selected{'AVAST_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='AVAST_UPDATE_METHOD' value='manually' $selected{'AVAST_UPDATE_METHOD'}{'manually'} />$Lang::tr{'copfilter disabled'}</td>
        <td nowrap valign='top'><input type='text' name='AVAST_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'AVAST_UPDATE_VALUE'}' />
        <select name='AVAST_UPDATE_PERIOD'>
               <option value='minutely' $selected{'AVAST_UPDATE_PERIOD'}{'minutely'}>$Lang::tr{'copfilter minutes'}</option>
               <option value='hourly' $selected{'AVAST_UPDATE_PERIOD'}{'hourly'}>$Lang::tr{'copfilter hours'}</option>
                <option value='daily' $selected{'AVAST_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'AVAST_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'AVAST_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>




        </select></td>
        <td nowrap valign='top'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter avast update now'}' />
END
;
if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_avast.done" ){
   print "<font color='#339933'>DONE</font>";
   system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_avast.done");
}

print <<END

	</td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>
<tr>
	<td nowrap> &nbsp;</td>
</tr>
END
;

}
















##### FPROT

if ($copfiltersettings{'FPROT_INSTALLED'} eq 'yes' ) {
my $status = "";
if ( -e "/var/log/copfilter/default/opt/f-prot/default/fpscand" ){ 
my $output = `/etc/rc.d/init.d/copfilter_f-protd pid weboutput`;
if ( $output =~ /OFF/ ) { $status="<td nowrap height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF' size='2.7em'><b> STOPPED <\/b><\/font></td>"; }
if ( $output =~ /NOT ACTIVATED/ ) { $status="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font></td>";; }
if ( $output =~ /ON/ ) { $status="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font></td>";; }
}
else {
if ($copfiltersettings{'FPROT_ENABLE'} eq 'on' ) {
$status="<td nowrap height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> NO DAEMON <\/b><\/font></td>"; }
else {
$status="<td nowrap height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font></td>"; }
}


print <<END
<table width='100%' border='0' cellpadding='5'>
<tr>
	<td nowrap width='11%'></td>
	<td nowrap width='14%'></td>
	<td nowrap width='75%'></td>
</tr>
<tr>
    <td nowrap><font size='2.7em'><b>F-Prot Status:</b></td>
    $status
</tr>
</table>

<table width='100%' border='0' cellpadding='2'>
<tr>
        <td nowrap width='6%'></td>
        <td nowrap width='3%'></td>
        <td nowrap width='91%'></td>
</tr>


<tr>
	<td nowrap><b><u>F-PROT:</u> * </b></td>
       	    <td nowrap> <select name='FPROT_ENABLE' style="border:2px solid $FPROTCOL;">
             <option value='on' $selected{'FPROT_ENABLE'}{'on'}>on</option>
             <option value='off' $selected{'FPROT_ENABLE'}{'off'}>off</option> </select>
        </td>
</tr>
</table>
<table width='100%' border='0' cellpadding='2'>
<tr>
        <td nowrap width='28%'></td>
        <td nowrap width='5%'></td>
        <td nowrap width='23%'></td>
        <td nowrap width='24%'></td>
        <td nowrap width='20%'></td>
</tr>
<tr>
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter fprot_sig'}:</b></td>
        <td nowrap colspan='2'><b>$Lang::tr{'copfilter automatic update'}:</b></td>
        <td nowrap colspan='1'><b>$Lang::tr{'copfilter manual update'}:</b></td>
</tr>
<tr>
        <td nowrap colspan='2'>
END
;

$output = "F-PROT ";
print "$output\n";
$output = `cat /var/log/copfilter/default/opt/f-prot/CURRENTVERSION |/bin/grep -E "^F-P" | cut -d "(" -f1 | sed "s/[^0-9.]//g"`;
print "$output\n";
$output = " - ";
print "$output\n";
$output = `cat /var/log/copfilter/default/opt/f-prot/CURRENTVERSION |/bin/grep -E "^E" |/bin/sed -e 'a\<br>' | sed -e 's/ version://'`;
print "$output\n";
$output = $Lang::tr{'copfilter sigdates'};
print "$output";
$output = `ls -la --time-style=long-iso /var/log/copfilter/default/opt/f-prot/default/ |grep antivir.def | sed 's/  */ /g' | cut -d " " -f 6-8`;
print "$output\n";
$output = `cat /var/log/copfilter/default/opt/f-prot/CURRENTVERSION |/bin/grep -E "^Li" |/bin/sed -e 'a\<br>'`;
print "<br>$output";

if ( -e "${copfilter_swroot}/opt/f-prot/LICENSE" ){
	$output = `cat /var/log/copfilter/default/opt/f-prot/LICENSE`;
	print "License expires at $output<br>";
}

######### zum naechsten F-Prot Update ################
if ( -e "${copfilter_swroot}/etc/fprot_counter" && $copfiltersettings{'FPROT_UPDATE_METHOD'} eq 'periodically' ){
my $nextupd = '';
my $nexttime = 0;
my $nextday = 0;
my $nexthour = 0;
my $nextminute = 0;
$nexttime = `cat /var/log/copfilter/default/etc/fprot_counter` + 5;

$nextday = ($nexttime - $nexttime % 1440) / 1440;
$nexthour = ($nexttime % 1440 - $nexttime % 1440 % 60) / 60;
$nextminute = $nexttime - $nextday * 1440 - $nexthour * 60;

if ($nextday > 0){
if ($nexthour < 10 ){ $nexthour = "0$nexthour"; }
if ($nextminute < 10){ $nextminute = "0$nextminute"; }
$nextupd = "<br><br><b>$nextday:$nexthour:$nextminute $Lang::tr{'copfilter days'} $Lang::tr{'fprot_update'} </b>";
}elsif($nexthour > 0){
if ($nextminute < 10){ $nextminute = "0$nextminute"; }
$nextupd = "<br><br><b>$nexthour:$nextminute $Lang::tr{'copfilter hours'} $Lang::tr{'fprot_update'} </b>";
}else{
$nextupd = "<br><br><b>$nextminute $Lang::tr{'copfilter minutes'} $Lang::tr{'fprot_update'} </b>";}
print "$nextupd";}



print <<END
</font>
</td>
        <td nowrap valign='top'><input type='radio' name='FPROT_UPDATE_METHOD' value='periodically' $selected{'FPROT_UPDATE_METHOD'}{'periodically'} />$Lang::tr{'copfilter enabled every'}: <br />
        <input type='radio' name='FPROT_UPDATE_METHOD' value='manually' $selected{'FPROT_UPDATE_METHOD'}{'manually'} />$Lang::tr{'copfilter disabled'}</td>
        <td nowrap valign='top'><input type='text' name='FPROT_UPDATE_VALUE' size='3' maxlength='3' value='$copfiltersettings{'FPROT_UPDATE_VALUE'}' />
        <select name='FPROT_UPDATE_PERIOD'>
                <option value='minutely' $selected{'FPROT_UPDATE_PERIOD'}{'minutely'}>$Lang::tr{'copfilter minutes'}</option>
                <option value='hourly' $selected{'FPROT_UPDATE_PERIOD'}{'hourly'}>$Lang::tr{'copfilter hours'}</option>
                <option value='daily' $selected{'FPROT_UPDATE_PERIOD'}{'daily'}>$Lang::tr{'copfilter days'}</option>
                <option value='weekly' $selected{'FPROT_UPDATE_PERIOD'}{'weekly'}>$Lang::tr{'copfilter weeks'}</option>
                <option value='monthly' $selected{'FPROT_UPDATE_PERIOD'}{'monthly'}>$Lang::tr{'copfilter months'}</option>
        </select></td>
        <td nowrap valign='top'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter fprot update now'}' />
END
;
if ( -e "${copfilter_swroot}/etc/copfilter_check-updates_f-prot.done" ){
   print "<font color='#339933'>DONE</font>";
   system ('/bin/rm', "${copfilter_swroot}/etc/copfilter_check-updates_f-prot.done");
}

print <<END

	</td>
</tr>
END
;

}

print <<END
<tr>
        <td nowrap>&nbsp; </td>
</tr>
<a name='renattach' />
<tr><td nowrap colspan='2'><u><b>$Lang::tr{'copfilter attachment renamer'}:</b></u></td></tr>
<tr>
    <td nowrap colspan='4'>$Lang::tr{'copfilter attachment renamer2'}</td>
</tr>

<tr>
    <td nowrap colspan='4'> $Lang::tr{'copfilter antivirus note'} </td>
</tr>


<tr>
        <td nowrap colspan='5'>$Lang::tr{'copfilter antivirus restart'}
END
;

if ($copfiltersettings{'THRDP_SHOW_GUI_ENABLE'} eq 'on') {
print <<END
	<br /> $Lang::tr{'copfilter automatic update email'} $Lang::tr{'copfilter clamd thrdp_mail'}
	<br /> $Lang::tr{'copfilter clamd thrdp_info'}
	<br /> $Lang::tr{'copfilter clamd thrdp_info2'}
	<br /> $Lang::tr{'copfilter clamd thrdp_info3'} <br /> $Lang::tr{'copfilter clamd thrdp_info4'}
	<br /> $Lang::tr{'copfilter clamd thrdp_info8'}
END
;
}
else {
print "<br> $Lang::tr{'copfilter automatic update email'}";
if ($THRDP eq 1){print "<br> $Lang::tr{'copfilter clamd thrdp_info'}";}
}

print <<END
</td> 

</tr>
<tr>
        <td nowrap valign='bottom' colspan='2'>
            <input type='checkbox' name='SKIP_RESTART' />
             $Lang::tr{'copfilter skip restart'}
        <br>
        <input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}' /> </td>
        <td nowrap> </td>
        <td nowrap> </td>
        <td nowrap valign='bottom'> <input type='submit' name='ACTION' value='$Lang::tr{'copfilter show virus quarantine'}' />
END
;
	if ( $nbr_virus gt 0){
	print "<b>&nbsp; (${nbr_virus}x)</b><img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>";
	}else{
	print "<img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>";}
print <<END
</tr>
</table>
END
;

print "</form>\n";
&Header::closebox();
print "<br />\n";


system('rm -f /tmp/count.aid >/dev/null 2>&1');

# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
